#include "GT30L24A3W.h"
#include "spi.h"

u8 *DZ_Data;//DZ_DataǱĵݵ顣
u8 *ZF_Code;

unsigned char Msb = 0,Lsb = 0;

/*******************************************************************************
 * : void Get_HzMat(unsigned char *code,unsigned char *msb,unsigned char *lsb)
 * : úߵֽں
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
void Get_HzMat(char *code,unsigned char *msb,unsigned char *lsb)
{
    *msb = *code;
    *lsb = *(++code);
}

/***************************************
ASCII 
ASCIICodeʾASCII 루8bits
BaseAdd˵ֿоƬеʼַ
r_dat_bat Ƕݺ
DZ_DataǱĵݵ顣
****************************************/
u8 ASCII_GetData(u8 asc,u32 BaseAdd,u8 *temp)
{
	if((asc >= 0x20) && (asc <= 0x7e))
	{	
		switch(BaseAdd)
		{
			case 0X1FBBE0: r_dat_bat((asc-0x20)*8+BaseAdd,8,temp);	 //5X7
			break ;
			case 0X1FBEE0:r_dat_bat((asc-0x20)*8+BaseAdd,8,temp);//7X8
			break ;
			case 0X1FC1E0:r_dat_bat((asc-0x20)*12+BaseAdd,12,temp); //6X12
			break ;
			case 0X1FC9E0:r_dat_bat((asc-0x20)*16+BaseAdd,16,temp); //8X16
			break ;
			case 0X179478:r_dat_bat((asc-0x20)*48+BaseAdd,48,temp); //12X24 Arial
			break ;
			case 0X17AC78:r_dat_bat((asc-0x20)*48+BaseAdd,48,temp); //12X24 Print
			break ;
			case 0X1FCFE0:r_dat_bat((asc-0x20)*64+BaseAdd,64,temp); //16X32
			break ;
			case 0X1FE7E0:r_dat_bat((asc-0x20)*26+BaseAdd+2,24,temp); //12X12 Arial
			break ;
			case 0X1FF1A0:r_dat_bat((asc-0x20)*34+BaseAdd+2,32,temp); //16X16 Arial
			break ;
			case 0X17D678:r_dat_bat((asc-0x20)*74+BaseAdd+2,72,temp); //24X24
			break ;
			case 0X1FFE60:r_dat_bat((asc-0x20)*130+ BaseAdd+2,128,temp);//32X32
			break;
			default:  break;
		}
		return 1;
	}
	else  
	{
		return 0; 
	}
}

/***************************************************
12 GB2312 ׼ֿ
˵
GBCodeʾ롣
MSB ʾGBCode ĸ8bits
LSB ʾGBCode ĵ8bits
Address ʾֻASCIIַоƬеֽڵַ
BaseAdd˵ֿоƬеʼַ
r_dat_bat Ƕݺ
DZ_DataǱĵݵ顣

úʾ

*****************************************************/
void gt_12_GetData (u8 MSB,u8 LSB,u8 *temp)
{
	 u8 temppp[18];
	 u32 BaseAdd = 0x202f20,Address;

	if(MSB == 0xA9 && LSB >= 0xA4)
	{
		Address = (282 + (LSB - 0XA4)) * 18 + BaseAdd;
	}
	else if(MSB >=0xA1 && MSB <= 0XA3 && LSB >=0xA1)
	{
		Address =( (MSB - 0xA1) * 94 + (LSB - 0xA1))*18+ BaseAdd;
	}
	else if(MSB >=0xB0 && MSB <= 0xF7 && LSB >=0xA1)
	{
		Address = ((MSB - 0xB0) * 94 + (LSB - 0xA1)+ 358)*18+ BaseAdd;
	}
	
	r_dat_bat(Address,18,temppp);
	
	Uncompress(temp,temppp);
}
//12ݽѹ
void Uncompress(unsigned char *des,unsigned char *src)
{
	unsigned char i;
	
	for(i=0;i<6;i++)
	{
	  *(des+i*4)   = *(src+i*3);
	  *(des+i*4+1) = (*(src+i*3+1)) & 0xf0;
	  *(des+i*4+2) = *(src+i*3+2);
	  *(des+i*4+3) = (*(src+i*3+1))<<4;
	}
} 


/***************************************************
16 GB2312 ׼ֿ
˵
GBCodeʾ롣
MSB ʾGBCode ĸ8bits
LSB ʾGBCode ĵ8bits
Address ʾֻASCIIַоƬеֽڵַ
BaseAdd˵ֿоƬеʼַ
r_dat_bat Ƕݺ
DZ_DataǱĵݵ顣
*****************************************************/
void gt_16_GetData (u8 MSB,u8 LSB,u8 *temp)
{
	 u32 BaseAdd = 0x22242C,Address;
	
	if(MSB==0xA9 && LSB >=0xA4)
	{
		Address=(282+(LSB-0XA4))*18+BaseAdd;
	}
	else if(MSB >=0xA1 && MSB <= 0XA3 && LSB >=0xA1)
	{
		Address =( (MSB - 0xA1) * 94 + (LSB - 0xA1))*32+ BaseAdd;
	}
	else if(MSB >=0xB0 && MSB <= 0xF7 && LSB >=0xA1)
	{
		Address = ((MSB - 0xB0) * 94 + (LSB - 0xA1)+ 358)*32+ BaseAdd;
	}
	
	r_dat_bat(Address,32,temp);
}
/**********************************************************************************
24X24  GBK  ׼ֿ 
u32 GBK_24_GetData(u8 c1,u8 c2) 
ܣ㺺ֵоƬеĵַ,ȡݱDZ_DataС 
c1,c22  ֽںͨc1,c2 룬 
أֵֽڵַ 
Section XʾX ַ 
************************************************************************************/
u32 GBK_24_GetData (unsigned char c1, unsigned char c2,u8 *temp) 
{ 
	 u32 h=0;
	 u32 Address,BaseAdd=0; 
	
	if(c2==0x7f) h=0; 
	if(c1>=0xA1 && c1 <= 0xa3 && c2>=0xa1)               //Section 1 
	{
		h= (c1 - 0xA1) * 94 + (c2 - 0xA1); 
	}
	else if(c1==0xA6 && c2>=0xa1) 
	{ 
		h= (c1 - 0xA6) * 94 + (c2 - 0xA1) + 282; 
	} 
	else if(c1==0xA9 && c2>=0xa1) 
	{ 
		h= (c1 - 0xA9) * 94 + (c2 - 0xA1) + 376; 
	} 
	if(c1>=0xb0 && c1 <= 0xf7 && c2>=0xa1)              //Section 2 
	{
		h= (c1 - 0xB0) * 94 + (c2 - 0xA1)+455; 
	}
	else if(c1<0xa1 && c1>=0x81 && c2>=0x40 )         //Section 3 
	{ 
		if(c2>0x7f) 
		{
			c2--; 
		}
		h=(c1-0x81)*190 + (c2-0x40) + 455 +6768; 
	} 
	else if(c1>=0xaa && c2<0xa1)                       //Section 4 
	{ 
		if(c2>0x7f) 
		{
			c2--; 
		}
		h=(c1-0xaa)*96 + (c2-0x40) + 455 +12848; 
	} 
	Address=h*72+BaseAdd;
	r_dat_bat(Address,72,temp);
	return Address;
} 


/*************************************************
8x16 shift-jis  İǼ 
˵ 
CODEı롣 
Address  ʾоƬеֽڵַ 
BaseAddr˵ֿоƬеʼַ 
**************************************************/
u32 Shift_Jis_8X16_GetData(u16 CODE)
{
	 u32 Address,BaseAddr = 0x2C714A; 
	if(CODE>=0XA1 && CODE<=0xDF) 
	{
		Address = (CODE-0Xa1)*16+BaseAddr;
	}
	
	r_dat_bat(Address,16,DZ_Data);
	
	return Address;
}

/************************************************** 
8x16 shift-jis  İǼunicode  
˵ 
CODEUNICODE 롣 
Address  ʾоƬеֽڵַ 
BaseAddr˵ֿоƬеʼַ 
***************************************************/
u32 Unicode_Shift_Jis_GetData(u16 CODE)
{
	 u32 Address,BaseAddr=0x2C714A; 
	
	if(CODE>=0xFF61 && CODE<=0xFF9F) 
	{
		Address = (CODE-0xFF61)*16+BaseAddr; 
	}
	
	r_dat_bat(Address,16,DZ_Data);
	
	return Address;
}

/*15X16 JIS0208 ı׼ֿ
˵
BaseAddrʾֿʼַ
MSBı߰λ
LSBıͰλ
*/
u32 JIS0208_16X16_GetData(u8 MSB,u8 LSB)
{
	 u32 Address ,BaseAddr=0x2C753A; 
	
	if(MSB<=15 && MSB>=1 && LSB<=94&&LSB>=1) 
	   Address=((MSB-1)*94+LSB-1)*32+BaseAddr; 
	if(MSB<=84 && MSB>=16 && LSB<=94&&LSB>=1) 
	   Address=((MSB-16)*94+LSB-1+1362)*32+BaseAddr; 
	if(MSB==85&&LSB<=60 && LSB>1) 
	   Address=((MSB-85)*94+LSB-2+690)*32+ BaseAddr; 
	if(MSB==85&&LSB==65) 
	   Address=((MSB-85)*94+LSB-65+748)*32+BaseAddr; 
	r_dat_bat(Address,32,DZ_Data);
	return Address;
}

/*16x16KSC5601ֿ⣨ַ֣
˵
MSBıĸ߰λ
LSBıĵͰλ
Address ʾоƬеֽڵַ
BaseAddr˵ֿоƬеʼַ
㷽*/
u32 KSC5601_F_16_GetData(u8 MSB,u8 LSB)
{
	 u32 Address,BaseAddr=0x303F3A; 
	
	if(MSB>=0xA1 && MSB<0xB0 && LSB>=0xA1) 
		Address =((MSB-0xA1)*94+(LSB-0xA1))*32+ BaseAddr; 
	else if(MSB>=0xB0 && MSB<=0XC8 && LSB>=0xA1) 
		Address = ((MSB-0xB0)*94+(LSB-0xA1)+1115)*32+BaseAddr; 
	r_dat_bat(Address,32,DZ_Data);
	return Address;
}

/*8x16ϵַ
˵
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽 */
u32 LATIN_8X16_GetData(u16 FontCode,u8 *temp)
{
	 u32 Address;
	
	if (FontCode>=0x0020 && FontCode<=0x007F) 
	   Address=(FontCode-0x0020) * 16 +0x27BFA8; 
	else if (FontCode>=0x00A0 && FontCode<=0x017F) 
	   Address=(FontCode-0x0040) * 16 +0x27BFA8; 
	else if (FontCode>=0x01A0 && FontCode<=0x01CF) 
	   Address=(FontCode-0x01A0+320) * 16 +0x27BFA8; 
	else if (FontCode>=0x01F0 && FontCode<=0x01FF) 
	   Address=(FontCode-0x01F0+368) * 16 +0x27BFA8; 
	else if (FontCode>=0x0210 && FontCode<=0x021F) 
	   Address=(FontCode-0x0210+384) * 16 +0x27BFA8; 
	else if (FontCode>=0x1EA0 && FontCode<=0x1EFF) 
	   Address=(FontCode-0x1EA0+400) * 16 +0x27BFA8; 
	r_dat_bat(Address,16,temp);
	return Address;
}

/*8x16ϣϵַ
˵ 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32 GREECE_8X16_GetData(u16 FontCode,u8 *temp)
{
	 u32 Address;
	
	if (FontCode>=0x0370 && FontCode<=0x03CF)
		Address=(FontCode-0x0370) * 16 +0x27DEA8;
	r_dat_bat(Address,16,temp);
	return Address;
}

/*8x16ϵַ
˵ 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32  CYRILLIC_8X16_GetData(u16 FontCode,u8 *temp)
{
	 u32 Address;
	
	if (FontCode>=0x0400 && FontCode<=0x045F)
		Address=(FontCode-0x0400) * 16 +0x27E4A8;
	else if (FontCode>=0x0490 && FontCode<=0x04FF)
		Address=(FontCode-0x0490+96) * 16 +0x27E4A8;
	r_dat_bat(Address,16,temp);
	return Address;
}

/*8x16ϣϵַ
˵ 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32 HEBREW_8X16_GetData(u16 FontCode,u8 *temp)
{
	 u32 Address;
	
	if (FontCode>=0x0590 && FontCode<=0x05FF) 
		Address=(FontCode-0x0590) * 16 +0x27F1A8; 
	if (FontCode>=0xFB1D && FontCode<=0xFB4F) 
		Address=(FontCode-0xFB1D) * 16 +0x27F1A8;
	r_dat_bat(Address,16,temp);
	return Address;
}

/*8x16ַ̩
˵ 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32 THAILAND_8X16_GetData(u16 FontCode,u8 *temp)
{
	 u32 Address;
	
	if (FontCode>=0x0E00 && FontCode<=0x0E5F)
		Address=(FontCode-0x0E00) * 16 +0x27FBD8;
	r_dat_bat(Address,16,temp);
	return Address;
}	

/*16󲻵ȿַ
˵ 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32 LATIN_16_GetData(u16 FontCode,u8 *temp)
{
	 u32 Address;
	
	if (FontCode>=0x0020 && FontCode<=0x007F)
		Address=(FontCode-0x0020) * 34 +0x2803D8;
	else if (FontCode>=0x00A0 && FontCode<=0x017F)
		Address=(FontCode-0x00A0+96) * 34 +0x2803D8;
	else if (FontCode>=0x01A0 && FontCode<=0x01CF)
		Address=(FontCode-0x01A0+320) * 34 +0x2803D8;
	else if (FontCode>=0x01F0 && FontCode<=0x01FF)
		Address=(FontCode-0x01F0+368) * 34 +0x2803D8;
	else if (FontCode>=0x0210 && FontCode<=0x021F)
		Address=(FontCode-0x0210+384) * 34 +0x2803D8;
	else if (FontCode>=0x1EA0 && FontCode<=0x1EFF)
		Address=(FontCode-0x1EA0+400) * 34 +0x2803D8;
	r_dat_bat(Address+2,32,temp);
	return Address;
}

/*16󲻵ȿϣַ
˵ 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32 GREECE_16_GetData(u16 FontCode,u8 *temp)
{
	 u32 Address;
	
	if (FontCode>=0x0370 && FontCode<=0x03CF)
		Address=(FontCode-0x0370) * 34 +0x2845B8;
	r_dat_bat(Address+2,32,temp);
	return Address;
}

/*16󲻵ȿַ
˵ 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ

㷽*/
u32 CYRILLIC_16_GetData(u16 FontCode,u8 *temp)
{
	 u32 Address;
	
	if (FontCode>=0x0400 && FontCode<=0x045F)
		Address=(FontCode-0x0400) * 34 +0x285278;
	else if (FontCode>=0x0490 && FontCode<=0x04FF)
		Address=(FontCode-0x0490+96) * 34 +0x285278;
	
	r_dat_bat(Address+2,32,temp);
	return Address;
}

/*16㲻ȿַ
˵ 
unicode_albʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32 ALB_16_GetData(u16 unicode_alb,u8 *temp)
{
	 u32 Address ,BaseAdd= 0x286E18;
	
	if( unicode_alb >= 0x0600 && unicode_alb <= 0x06FF )
		Address = 34*(unicode_alb-0x0600)+BaseAdd;
	else if( unicode_alb >= 0xfb50 && unicode_alb <= 0xfbff )
		Address = 34*(16*16+unicode_alb-0xfb50)+ BaseAdd;
	else if( unicode_alb >= 0xfe70 && unicode_alb <= 0xfeff )
		Address = 34*(16*11+16*16+unicode_alb-0xfe70)+ BaseAdd;
	
	r_dat_bat(Address+2,32,temp);
	
	return Address;
}


/********************************************************
16 㲻ȿַ 
˵ 
FontCodeʾunicode 루16bits 
AddressʾֵоƬеֽڵַ 
*********************************************************/
u32 Indic_16_GetData(u16 FontCode)
{
	 u32 Address;
	
	if (FontCode>=0x0900 && FontCode<=0x09FF) 
		Address=(FontCode-0x0900) * 34 +0x28BADC; 
	
	r_dat_bat(Address+2,32,DZ_Data);
	return Address;
}


/*12x24ϵַ
˵
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽 */
u32 LATIN_12X24_GetData(u16 FontCode)
{
	 u32 Address;
	
	if (FontCode>=0x0020 && FontCode<=0x007F) 
		Address=(FontCode-0x0020) * 48 +0x28CBDC; 
	else if (FontCode>=0x00A0 && FontCode<=0x017F) 
		Address=(FontCode-0x0040) * 48 +0x28CBDC; 
	else if (FontCode>=0x01A0 && FontCode<=0x01CF) 
		Address=(FontCode-0x01A0+320) * 48 +0x28CBDC; 
	else if (FontCode>=0x01F0 && FontCode<=0x01FF) 
		Address=(FontCode-0x01F0+368) * 48 +0x28CBDC; 
	else if (FontCode>=0x0210 && FontCode<=0x021F) 
		Address=(FontCode-0x0210+384) * 48 +0x28CBDC; 
	else if (FontCode>=0x1EA0 && FontCode<=0x1EFF) 
		Address=(FontCode-0x1EA0+400) * 48 +0x28CBDC; 
	
	r_dat_bat(Address,48,DZ_Data);
	return Address;
}

/*16X24ַ̩
˵ 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32 THAILAND_16X24_GetData(u16 FontCode,u8 *temp)
{
	 u32 Address;
	
	if (FontCode>=0x0E00 && FontCode<=0x0E5F)
		Address=(FontCode-0x0E00) * 50 +0X2A7180;
	r_dat_bat(Address+2,48,temp);
	return Address;
}		




/***************************************************************
24 㲻ȿַ 
˵ 
FontCodeʾunicode 루16bits 
AddressʾַоƬеֽڵַ. 
BaseAddʾֿоƬеʼַ 
****************************************************************/
u32  Khmer_24_GetData(u16 FontCode,u8 *temp)
{
	u32 Address,BaseAdd=0x2B29C6; 

	if (FontCode>=0x1780 && FontCode<=0x17DD) 
	{
	   Address=(FontCode-0x1780) * 74 +BaseAdd; 
	}
	if (FontCode>=0x17E0 && FontCode<=0x17E9) 
	{
	   Address=(FontCode-0x17E0) * 74 +BaseAdd+0x1b2c; 
	}
	if (FontCode>=0x17F0 && FontCode<=0x17F9) 
	{
	   Address=(FontCode-0x17F0) * 74 +BaseAdd+0x1e10; 
	}
	if (FontCode>=0x19e0 && FontCode<=0x19EF) 
	{
	   Address=(FontCode-0x19e0) * 74 +BaseAdd+0x22b0; 
	}
	if (FontCode>=0x19F0 && FontCode<=0x19FF) 
	{
	   Address=(FontCode-0x19f0) * 74 +BaseAdd+0x2878; 	
	}

	r_dat_bat(Address+2,72,temp);
	return Address;
}   

/***************************************************************************
 24X24 GB18030 չַּ 
u32 GB18030_24_GetData(u8 c1, u8 c2, u8 c3, u8 c4) 
ܣ㺺ֵоƬеĵַ,ȡݱDZ_DataС 
c1,c2,c3,c44  ֽںͨ c1,c2,c3,c4  룬˫ֽͨ c1,c2  룬 
c3=0,c4=0 
أֵֽڵַ 
BaseAdd:  ˵ֵֿоƬеʼַBaseAdd0x17F24C; 
Section XʾX ַ 
****************************************************************************/
u32 GB18030_24_GetData (u8 c1, u8 c2, u8 c3, u8 c4) 
{ 
	 u32 Address,BaseAdd = 0x17F24C,h=0; 
	
	if(c2==0x7f) h=0; 
	
	if(c1>=0xa4 && c1 <= 0xa5 && c2>=0xa1)                    //Section 1 
	{
		h= (c1 - 0xA4) * 94 + (c2 - 0xA1); 
	}
	else if(c1>=0xa7 && c1 <= 0xa8 && c2>=0xa1) 
	{
		h= (c1 - 0xA7) * 94 + (c2 - 0xA1) + 188; 
	}
	else if(c1>=0xa8 && c1 <= 0xa9 && c2<0xa1)               //Section 5 
	{ 
		if(c2>0x7f) 
		{
			c2--; 
		}
		h=(c1-0xa8)*96 + (c2-0x40)+376; 
	} 
	else if(c1==0x81 && c2>=0x39)            //ֽ1 
	{ 
		h =(c3-0xEE)*10+c4-0x39+558; 
	} 
	else if(c1==0x82)          //ֽ2 
	{ 
		h =161+558+(c2-0x30)*1260+(c3-0x81)*10+c4-0x30; 
	} 
	
	Address=h*72+BaseAdd;
	r_dat_bat(Address,72,DZ_Data);
	
	return Address;
} 



/*24x24KSC5601ֿ⣨ַ֣
˵
MSBıĸ߰λ
LSBıĵͰλ
Address ʾоƬеֽڵַ
BaseAddr˵ֿоƬеʼַ
㷽*/
u32 KSC5601_F_24_GetData(u8 MSB,u8 LSB)
{
	 u32 Address,BaseAddr=0x3A82F2; 
	
	if(MSB>=0xA1&&MSB<0xB0&&LSB>=0xA1) 
		Address =((MSB-0xA1)*94+(LSB-0xA1))*72+ BaseAddr; 
	else if(MSB>=0xB0 && MSB<=0XC8 && LSB>=0xA1) 
		Address = ((MSB-0xB0)*94+(LSB-0xA1))*72+35680+BaseAddr; 
	
	r_dat_bat(Address,72,DZ_Data);
	return Address;
}		




/*12x24ϣϵַ
˵ 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32 GREECE_12X24_GetData(u16 FontCode)
{
	 u32 Address;
	
	if (FontCode>=0x0370 && FontCode<=0x03CF)
		Address=(FontCode-0x0370) * 48 +0x2928DC;
	r_dat_bat(Address,48,DZ_Data);
	return Address;
}
/*12x24ϵַ
˵ 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32  CYRILLIC_12X24_GetData(u16 FontCode)
{
	 u32 Address;
	
	if (FontCode>=0x0400 && FontCode<=0x045F)
		Address=(FontCode-0x0400) * 48 +0x293ADC;
	else if (FontCode>=0x0490 && FontCode<=0x04FF)
		Address=(FontCode-0x0490+96) * 48 +0x293ADC;
	r_dat_bat(Address,48,DZ_Data);
	return Address;
}
/*12x24ϣϵַ
˵ 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32 HEBREW_12X24_GetData(u16 FontCode)
{
	 u32 Address;
	
	if (FontCode>=0x0590 && FontCode<=0x05FF) 
		Address=(FontCode-0x0590) * 48 +0x2961DC; 
	if (FontCode>=0xFB1D && FontCode<=0xFB4F) 
		Address=(FontCode-0xFB1D) * 48 +0x2961DC;
	r_dat_bat(Address,48,DZ_Data);
	return Address;
}


/*24㲻ȿַ
˵ 
unicode_albʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽*/
u32 ALB_24_GetData(u16 UNICODE_alb)
{
	 u32 Address ,BaseAdd= 0x2A8346; 
	
	if( UNICODE_alb >= 0x0600 && UNICODE_alb <= 0x06FF )//alb 1 
		Address = 74 *(UNICODE_alb-0x0600)+ BaseAdd; 
	else if( UNICODE_alb >= 0xfb50 && UNICODE_alb <= 0xfbff )//alb 2 
		Address = 74 *(16*16+UNICODE_alb-0xfb50)+ BaseAdd; 
	else if( UNICODE_alb >= 0xfe70 && UNICODE_alb <= 0xfeff )//alb 3 
		Address = 74 *(16*11+16*16+UNICODE_alb-0xfe70)+ BaseAdd; 
	
	r_dat_bat(Address+2,72,DZ_Data);
	return Address;
}	

/***********************************************************
CODE PAGE  ַ 
˵ 
CODECODE PAGE  롣 
Address  ʾCODE PAGE  ӦUNICODE оƬеֽڵַ 
Group˵CODE PAGE  ӦUNICODE  
***********************************************************/

u32 CodePage_UC(u8 CODE,u8 Group)
{
	 u32 Address;
	
	if (CODE<=0xFF)
	{
		switch (Group)
		{
			case 0:Address =CODE*2+0x2B56DE; //437-usa
			break;
			case 1:Address=CODE*2 +0x2B58DE; //737-greek
			break;
			case 2:Address=CODE*2 +0x2B5ADE; //775-baltic
			break;
			case 3:Address=CODE*2 +0x2B5CDE; //850-Multilingual
			break;
			case 4:Address=CODE*2 +0x2B5EDE; //852-Latin2
			break;
			case 5:Address=CODE*2 +0x2B60DE; //855-cyrillic
			break;
			case 6:Address=CODE*2 +0x2B62DE; //857-turkis
			break;
			case 7:Address=(CODE-0x80)*2 +0x2B64DE; //858-euro
			break;
			case 8:Address =CODE*2+0x2B65DE; //860-portugese
			break;
			case 9:Address=CODE*2 +0x2B67DE; //862-hebrow
			break;
			case 10:Address=CODE*2 +0x2B69DE; //863-canadian/french
			break;
			case 11:Address=CODE*2 +0x2B6BDE; //864-arabic
			break;
			case 12:Address=CODE*2 +0x2B6DDE;	//865-nordic
			break;
			case 13:Address=CODE*2 +0x2B6FDE;	//866-cyrillic2
			break;
			case 14:Address=CODE*2 +0x2B71DE;	//1251-cyrillic
			break;
			case 15:Address=CODE*2 +0x2B73DE;	//1252-latin1
			break;
			case 16:Address=CODE*2 +0x2B75DE; //1253-greek
			break;
			case 17:Address=CODE*2 +0x2B77DE;	//1254-turkis
			break;
			case 18:Address =CODE*2+0x2B79DE;	//1255-hebrewNew
			break;
			case 19:Address=CODE*2 +0x2B7BDE;	//1256-arabic
			break;
			case 20:Address=CODE*2 +0x2B7DDE; //1257-baltic
			break;
			case 21:Address=(CODE-0xa0)*2 +0x2B7FDE; //928-greek 
			break;
			case 22:Address=(CODE-0x20)*2 +0x2B809E; //hebrow old
			break;
			case 23:Address = (CODE-0x80)*2+0x2B815E; //katakana
			break;		 				  		 				  
			default:break;
		}
	}	
	return Address;
} 
/********************************************************************************
INTERNATIONAL CHARACTER 
˵ 
Icode:INTERNATIONAL CHARACTER CODE 롣 
CODE[]INTERNATIONAL CHARACTER CODE  TABLE 
Address  ʾCODE PAGE  ӦUNICODE оƬеֽڵַ 
BaseAddr˵CODE PAGE  ӦUNICODE  ֿоƬеʼַ
         USA    :0x2B825E
		 FRANCE :0x2B8276
		 GERMANY:0x2B828E
		 U.K    :0x2B82A6
		 DENMARK:0x2B82BE
		 SWEDEN :0x2B82D6
		 LTALY  :0x2B82EE
		 SPAIN  :0x2B8306
		 JAPAN  :0x2B831E
		 NORWAY :0x2B8336
		 DENMARK II:0x2B834E
		 
*********************************************************************************/
u32 ICCS_Addr(u8 Icode,u32 BaseAddr)
{
	char i;
	 u32 Address;
	
	char CODE[12]={0x23,0x24,0x40,0x5b,0x5c,
	0x5d,0x5e,0x60,0x7b,0x7c,0x7d,0x7e};
	
	for(i=0;i<12;i++)
	{
		if(Icode==CODE[i])
		{
			Address=i*2+BaseAddr;
			i=12;
		}
	}
	return Address;
}

/********************************************************************************
Katakana ַ÷ 
˵ 
CODECODE PAGE KATAKANA 롣 
Address  ʾоƬеֽڵַ 
BaseAddr˵ֿоƬеʼַ 
*********************************************************************************/
u32 Katakana_GetData(u8 CODE)
{ 
	 u32 Address,BaseAddr=0x2BE336; 
	
	if(CODE>=0x80 && CODE<=0x9F) 
	{
		Address = (CODE-0x80)*72+BaseAddr; 
		r_dat_bat(Address,72,DZ_Data);
	}
	else if(CODE>=0xA1 && CODE<=0xDF) 
	{
		Address = (CODE-0xA1)*48+0x26F3A2;
		r_dat_bat(Address,48,DZ_Data); 
	}
	else if(CODE>=0xE0 && CODE<=0xFF) 
	{
		Address = (CODE-0xE0)*72+0x920+BaseAddr;
		r_dat_bat(Address,72,DZ_Data); 
	}
	return Address;
} 
/*****************************************************************************
COPE PAGE UNICODE
CODECODE PAGE KATAKANA롣 
Address ʾCODE PAGEӦUNICODEоƬеֽڵַ 
BaseAddr˵CODE PAGEӦUNICODEֿоƬеʼַ

******************************************************************************/
u32 CodePage_patch(u16 CODE)
{
	 u32 Address,BaseAddr=0x07603C;
	
	if (CODE==0x0192){
		Address=BaseAddr;
	}
	else if (CODE>=0x0393 && CODE<=0x03c6){
		Address=(CODE-0x0393+1)*48+BaseAddr;
	}
	else if (CODE>=0x2013 && CODE<=0x20ac){
		Address=(CODE-0x2013+0x35)*48+BaseAddr;
	}
	else if (CODE>=0x2219 && CODE<=0x2265){
		Address=(CODE-0x2219+0xCf)*48+BaseAddr;
	}
	else if (CODE>=0x2310 && CODE<=0x2321){
		Address=(CODE-0x2310+0x11c)*48+BaseAddr;
	}
	else if (CODE>=0x2500 && CODE<=0x25a0){
		Address=(CODE-0x2500+0x12e)*48+BaseAddr;
	}
	else if (CODE>=0x02c6 && CODE<=0x02dd){
		Address=(CODE-0x02c6+0x1Cf)*48+BaseAddr;
	}
	else if (CODE>=0x2116 && CODE<=0x2122){
		Address=(CODE-0x2116+0x1E7)*48+BaseAddr;
	}
	else
		return 0;
		r_dat_bat(Address,48,DZ_Data);
	return Address;
}
/************************************************************************
CODE PAGE 8X16  ַ÷ 
˵ 
cp_patch1[19]:COPE PAGE  δ173 ֮ڵunicode б 
code:CODE PAGE  ת unicode ÷ó unicode  
index:unicode cp_patch1        е 
addr:unicode  ֿеĵַ 
*************************************************************************/
u32 CP_Patch_8X16_GetData(u16 CODE)
{
	 u32 Address,BaseAddr=0x2B8366; 
	
	u16 cp_patch1[19]={0x003d,0x0192,0x02C6,0x02DC,0x0686,0x0698,0x2017,0x201A,0x201E,0x2022, 
	0x2039,0x203A,0x2219,0x2310,0x2320,0x2321,0x2580,0x2590,0x2591}; 
	u8 i,index; 
	
	for(i=0;i<19;i++)
	{ 
		if(CODE==cp_patch1[i])
		{ 
			index=i; 
			break; 
		} 
	} 
	
	Address=index*16+BaseAddr;
	r_dat_bat(Address,16,DZ_Data);
	
	return Address; 
}
/************************************************************************
CODE PAGE 16X16  ַ÷ 
˵ 
code:CODE PAGE  ת unicode ÷ó unicode  
addr:unicode  ֿеĵַ 
*************************************************************************/
u32 CP_Patch_16X16_GetData(u16 CODE)
{
	u32 addr,BaseAddr=0x2B8496; 
	
	if(CODE==0x20a7) 
		addr=BaseAddr; 
	if(CODE==0x20aa) 
		addr=BaseAddr+32; 
	
	r_dat_bat(addr,32,DZ_Data);
	return addr;
}

/************************************************************************
CODE PAGE KATAKANA 16X16  ַ÷ 
˵ 
code:CODE PAGE KATAKANA  
addr:unicode  ֿеĵַ 
*************************************************************************/
u32 CP_P_KATAKANA_16X16_GetData(u16 CODE)
{
	u32 addr,BaseAddr=0x2B84D6; 
	
	if(CODE>=0xe0 && CODE<=0xe3) 
		addr=(CODE-0xe0)*32+BaseAddr; 
	else if(CODE==0xfe) 
		addr=0x2B8556;
	
	r_dat_bat(addr,32,DZ_Data);
	return addr; 
}

/*************************************************************************
12X24 COPE PAGE  UNICODE  
CODECODE PAGE KATAKANA 롣 
Address  ʾоƬеֽڵַ 
BaseAddr˵ֿоƬеʼַ 
**************************************************************************/
u32 CP_P_KATAKANA_12X24_UniCode_GetData(u16 CODE)
{
	u32 Address,BaseAddr=0x2B8576; 
	
	if (CODE==0x0192){ 
		Address=BaseAddr; 
	} 
	else if (CODE>=0x0393 && CODE<=0x03c6){ 
		Address=(CODE-0x0393+1)*48+BaseAddr; 
	} 
	else if (CODE>=0x2013 && CODE<=0x20ac){ 
		Address=(CODE-0x2013+0x35)*48+BaseAddr; 
	} 
	else if (CODE>=0x2219 && CODE<=0x2265){ 
		Address=(CODE-0x2219+0xCf)*48+BaseAddr; 
	} 
	else if (CODE>=0x2310 && CODE<=0x2321){ 
		Address=(CODE-0x2310+0x11c)*48+BaseAddr; 
	} 
	else if (CODE>=0x2500 && CODE<=0x25a0){ 
		Address=(CODE-0x2500+0x12e)*48+BaseAddr; 
	} 
	else if (CODE>=0x02c6 && CODE<=0x02dd){ 
		Address=(CODE-0x02c6+0x1Cf)*48+BaseAddr; 
	} 
	else if (CODE>=0x2116 && CODE<=0x2122){ 
		Address=(CODE-0x2116+0x1E7)*48+BaseAddr; 
	} 
	else 
	return 0; 
	r_dat_bat(Address,48,DZ_Data);
	return Address;   
}
/*ISO8859  8X16
ISO8859-1˵20h-7Fhο5x7 ASCIIã 
FontCodeʾunicode루16bits
AddressʾֵоƬеֽڵַ
㷽 */
u32 ISO8859_GetData(u16 FontCode,u8 Num)
{
	u32 address=0;

	if(FontCode >=0x0080 && FontCode <=0x00FF)
	{

		switch (Num)
		{
			case 1:	address =(FontCode-0x80) * 16 + 0x2C0136;
			break;
			case 2: address =(FontCode-0x80) * 16 + 0x2C0936;
			break;    
			case 3:	address =(FontCode-0x80) * 16 + 0x2C1136;
			break;
			case 4:	address =(FontCode-0x80) * 16 + 0x2C1936;
			break;
			case 5:	address =(FontCode-0x80) * 16 + 0x2C2136;
			break;
			case 7:	address =(FontCode-0x80) * 16 + 0x2C2936;
			break;
			case 8:	address =(FontCode-0x80) * 16 + 0x2C3136;
			break;
			case 9:	address =(FontCode-0x80) * 16 + 0x2C3936;
			break;
			case 10:address =(FontCode-0x80) * 16 + 0x2C4136;
			break;
			case 11:address =(FontCode-0x80) * 16 + 0x2C4936;
			break;
			case 13:address =(FontCode-0x80) * 16 + 0x2C5136;
			break;
			case 14:address =(FontCode-0x80) * 16 + 0x2C5936;
			break;																								 
			case 15:address =(FontCode-0x80) * 16 + 0x2C6136;
			break;
			case 16:address =(FontCode-0x80) * 16 + 0x2C6936;		
			break;
			default:break;
		}
		r_dat_bat(address,16,DZ_Data);
	}
	return address;
}

//UNICODEת JIS0208ת
/*
void U2J(WORD Unicode,BYTE* JIS);
ܣUnicodeתΪı루תıӦunicode
 Unicode ʾҪתunicode룻JIS ʾָBYTEָ룬ڴת
ı롣ZF_Code[0]Ÿ8λZF_Code[1]ŵ8λ.
ֵա
r_dat_bat(u32 address,u8 byte_long,u8 *p_arr);
Address   ʾַоƬеֽڵַ
byte_long Ƕֽ
*p_arr    Ǳĵݵ顣
ܣֿоƬַȡBYTEݡ
ֿŵĵַ
JIS0208_GetData(MSB,LSB);
ֿó򣬵Ӧĵݡ
*/
u32 U2J_GetData(u16 Unicode)
{
	u32  unicodenum,BaseAddr=0x3E517A;
	
	if(Unicode < 0x07ff && Unicode >= 0x0020)
	{
		unicodenum = Unicode - 0x0020;
	}
	else if(Unicode <0x27ff && Unicode >=0x2000)
	{
		unicodenum = Unicode - 0X1820;
	}
	else if(Unicode <0x30ff && Unicode >=0x3000)
	{
		unicodenum = Unicode - 0x2020;
	}
	else if(Unicode <0x33ff && Unicode >= 0x3200)
	{
		unicodenum = Unicode - 0x2120;
	}
	else if(Unicode <0x9fff && Unicode >= 0x4e00)
	{
		unicodenum = Unicode - 0x3b20;
	}
		else if(Unicode <0xffff && Unicode >= 0xfe00)
	{
	 	unicodenum = Unicode - 0x9920;
	}
	else if(Unicode<=0x2B07 && Unicode>=0x2B05) 
    { 
      ZF_Code[0]=12; 
      ZF_Code[1]=Unicode-0x2ACF; 
	}
	if (Unicode<0x2B05 || Unicode>0x2B07)
	r_dat_bat(unicodenum*2+BaseAddr,2,ZF_Code);	
    JIS0208_16X16_GetData(ZF_Code[0],ZF_Code[1]);
 return (unicodenum*2+BaseAddr); 
} 
/********************************************************
ShiftCJIS תJIS0208 ת 
˵
Address:ʾҪѯַnunicode еĵַ 
BaseAddr:  ʾunicode ʼλá 
CODEҪתSHIFT-JIS 롣 
********************************************************/
u32 Shift_JIS_TO_JIS0208(u16 Code16)
{
    u32 BaseAddr=0x3F1F3A; 
	if(Code16>=0x8140 && Code16<=0x9FFC) 
	{
		r_dat_bat(2*(Code16-0x8100) +BaseAddr,2,ZF_Code);
		ZF_Code[0] -=0x20;
        ZF_Code[1] -= 0x20;
		
     }
	else if(Code16>=0xE040 && Code16<=0xEAA4) 
	{
		r_dat_bat(2*(Code16-0xc140) +BaseAddr,2,ZF_Code);
		ZF_Code[0] -=0x20;
        ZF_Code[1] -= 0x20;
	}
	else if(Code16>=0x8740 && Code16<=0x879C)
	{
		r_dat_bat(2*(Code16-0x8740) +BaseAddr,2,ZF_Code);
		ZF_Code[0] -=0x20;
        ZF_Code[1] -= 0x20;
	}
	else if(Code16>0x879C && Code16<=0x9FFC)
{
    r_dat_bat(2*(Code16-0x879c) +BaseAddr,2,ZF_Code);
		ZF_Code[0] -=0x20;
        ZF_Code[1] -= 0x20;
}
	else if(Code16>=0xeeef && Code16<=0xeef8)
	{
		ZF_Code[0]=0xee-0xe4;
		ZF_Code[1]=((unsigned char)Code16)-0xDA;
	}
	else if(Code16>=0xfa40 && Code16<=0xfa49)
	{
		ZF_Code[0]=0xfa-0xf0;
		ZF_Code[1]=((u8)Code16)-0x2b;
	}
	else if(Code16>=0xfa4a && Code16<=0xfa53)
	{
		ZF_Code[0]=0xfa-0xf0;
		ZF_Code[1]=((u8)Code16)-0x49;
	}
	else if(Code16==0xfa58)
	{
		 ZF_Code[0]=13;   ZF_Code[1]=14;
	}
	else if(Code16==0xfa59)
	{
		ZF_Code[0]=11;   ZF_Code[1]=91;
	}
	else if(Code16==0xfa5a)
	{
		ZF_Code[0]=11;   ZF_Code[1]=93;
	}
	else if(Code16==0xfa5b)
	{
		ZF_Code[0]=02;  ZF_Code[1]=72;
	}
return ZF_Code[0];
}
/*15X16 unicode úĳ
void U2K(WORD Unicode,BYTE* KSC5601);
ܣUnicodeתΪı루תıӦunicode
 Unicode ʾҪתunicode룻ZF_CodeʾָBYTEָ룬
ڴתĺıZF_Code[0]Ÿ8λZF_Code[1]ŵ8λ.
ֵա
˵
BaseAddr: ʾunicodeʼλá
unicodenum : ʾaddressunicodeеš
r_dat_bat(u32 address,u8 byte_long,u8 *p_arr);
Address   ʾַоƬеֽڵַ
byte_long Ƕֽ
*p_arr    Ǳĵݵ顣
ܣֿоƬַȡBYTEݡ
ֿŵĵַ

KSC5601_F_GetData(MSB,LSB),úĳ;
*/

u32 U2K_GetData(u16 Unicode)
{
	u32  BaseAddr=0x3F72BE,unicodenum;

	if(Unicode <= 0x0451 && Unicode >=0x00a1)
	{
		unicodenum = Unicode - 0x00a1;
	}
	else if(Unicode <=0x266d && Unicode >= 0x2015)
	{
		unicodenum = Unicode - 0X1c64;
	}
	else if(Unicode <=0x33dd && Unicode >= 0x3000)
	{
		unicodenum = Unicode - 0x25f6;
	}
	else if(Unicode <=0xd79d && Unicode >= 0xac00) 
      { 
        unicodenum = Unicode - 0x9E18; 
      } 
    else if(Unicode <=0xffff && Unicode >= 0xf900) 
      { 
           unicodenum = Unicode - 0xBF7A; 
      } 
	r_dat_bat(BaseAddr+unicodenum*2,2,ZF_Code);
	KSC5601_F_16_GetData(ZF_Code[0],ZF_Code[1]);
	return (BaseAddr+unicodenum*2);
}

void SendByte(u32 cmd)
{
	u8 i;
	
	cmd = cmd | 0x03000000;
	for(i=0;i<32;i++)
	{
		CLK_L;
		if(cmd & 0x80000000)
		{
			SI_H;
			__NOP();
		}
		else 
		{
			SI_L;
			__NOP();
		}
		CLK_H;
		cmd = cmd << 1;
	}
	__NOP();
	__NOP();
}

u8 ReadByte(void)
{
	u8 i;
	u8 dat = 0;
	
	CLK_H;
	for(i=0;i<8;i++)
	{
		CLK_L;
		dat = dat << 1;
		if(SO)
		{
			dat = dat | 0x01;
		}
		else 
		{
			dat &= 0xfe;
		}
		CLK_H;		
	}	
	
	return dat;
}

/****************************************************
ֿжݺ
˵
Address   ʾַоƬеֽڵַ
byte_long Ƕֽ
*p_arr    Ǳĵݵ顣
*****************************************************/
u8 r_dat_bat(u32 address,u8 byte_long,u8 *p_arr)
{
	unsigned int j=0;
	FONT_CS = 0;
	SendByte(address);
	for(j=0;j<byte_long;j++)
	{
	 p_arr[j]=ReadByte();
	}
	FONT_CS = 1;
	return p_arr[0];	
}

/*******************************************************************************
 * : void Gt30l_Font_Init(void)
 * : ֿоƬʼ
 * β: 
 * : 
 * ˵: 
 ******************************************************************************/
void Gt30l_Font_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_4 | GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
    
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;  
    GPIO_Init(GPIOA, &GPIO_InitStructure);

 	GPIO_SetBits(GPIOA,GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7);
}

///****************************************************
//ֿжݺ
//˵
//Address   ʾַоƬеֽڵַ
//byte_long Ƕֽ
//*p_arr    Ǳĵݵ顣
//*****************************************************/
//u8 r_dat_bat(u32 address,u8 byte_long,u8 *p_arr)
//{
//	unsigned int j=0;
//    u8 dat1,dat2,dat3,dat4;

//    address = address | 0x03000000;
//    
//    dat1 = address >> 24;
//    dat2 = address >> 16;
//    dat3 = address >> 8;
//    dat4 = address;
//    
//	FONT_CS = 0;

//	SPIx_ReadWriteByte(dat1);  //24bitַ    
//	SPIx_ReadWriteByte(dat2);  //24bitַ    
//	SPIx_ReadWriteByte(dat3);   
//	SPIx_ReadWriteByte(dat4);   

//	for(j=0;j<byte_long;j++)
//	{
//		p_arr[j] = SPIx_ReadWriteByte(0xff);   //ѭ  
//	}
//	FONT_CS = 1;
//	return p_arr[0];	
//}

///*******************************************************************************
// * : void Gt30l_Font_Init(void)
// * : ֿоƬʼ
// * β: 
// * : 
// * ˵: 
// ******************************************************************************/
//void Gt30l_Font_Init(void)
//{
//	GPIO_InitTypeDef GPIO_InitStructure;
//    
//	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;  //SPI CS
// 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  
//    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
// 	GPIO_Init(GPIOA, &GPIO_InitStructure);
// 	GPIO_SetBits(GPIOA,GPIO_Pin_4);
//    
//    SPIx_Init();		   //ʼSPI	
//}

