#ifndef  __GT30L_H__
#define  __GT30L_H__

#include "sys.h"

extern  u8 *DZ_Data;//DZ_DataǱĵݵ顣
extern  u8 *ZF_Code;

#define FONT_CS    PAout(4)
#define FONT_CLK   PAout(5)
#define FONT_S0    PAin(6)
#define FONT_SI    PAout(7)

#define CLK_H    FONT_CLK = 1
#define CLK_L    FONT_CLK = 0

#define SI_H     FONT_SI = 1
#define SI_L     FONT_SI = 0

#define SO       FONT_S0     

void Gt30l_Font_Init(void);

void Get_HzMat(char *code,unsigned char *msb,unsigned char *lsb);
extern unsigned char Msb,Lsb;

u8 r_dat_bat(u32 address,u8 byte_long,u8 *p_arr);
u32 U2K_GetData(u16 Unicode);
u32 Shift_JIS_TO_JIS0208(u16 Code16);
u32 U2J_GetData(u16 Unicode);
u32 ISO8859_GetData(u16 FontCode,u8 Num);
u32 CP_P_KATAKANA_12X24_UniCode_GetData(u16 CODE);
u32 CP_P_KATAKANA_16X16_GetData(u16 CODE);
u32 CP_Patch_16X16_GetData(u16 CODE);
u32 CP_Patch_8X16_GetData(u16 CODE);
u32 CodePage_patch(u16 CODE);
u32 Katakana_GetData(u8 CODE);
u32 ICCS_Addr(u8 Icode,u32 BaseAddr);
u32 CodePage_UC(u8 CODE,u8 Group);
u32  Khmer_24_GetData(u16 FontCode,u8 *temp);
u32 ALB_24_GetData(u16 UNICODE_alb);
u32 THAILAND_16X24_GetData(u16 FontCode,u8 *temp);
u32 HEBREW_12X24_GetData(u16 FontCode);
u32  CYRILLIC_12X24_GetData(u16 FontCode);
u32 GREECE_12X24_GetData(u16 FontCode);
u32 LATIN_12X24_GetData(u16 FontCode);
u32 Indic_16_GetData(u16 FontCode);


u32 ALB_16_GetData(u16 unicode_alb,u8 *temp);
u32 CYRILLIC_16_GetData(u16 FontCode,u8 *temp);
u32 GREECE_16_GetData(u16 FontCode,u8 *temp);
u32 LATIN_16_GetData(u16 FontCode,u8 *temp);
u32 THAILAND_8X16_GetData(u16 FontCode,u8 *temp);
u32 HEBREW_8X16_GetData(u16 FontCode,u8 *temp);
u32 CYRILLIC_8X16_GetData(u16 FontCode,u8 *temp);
u32 GREECE_8X16_GetData(u16 FontCode,u8 *temp);
u32 LATIN_8X16_GetData(u16 FontCode,u8 *temp);
u32 KSC5601_F_24_GetData(u8 MSB,u8 LSB);
u32 KSC5601_F_16_GetData(u8 MSB,u8 LSB);
u32 JIS0208_16X16_GetData(u8 MSB,u8 LSB);


u32 Unicode_Shift_Jis_GetData(u16 CODE);
u32 Shift_Jis_8X16_GetData(u16 CODE);
u32 GB18030_24_GetData (u8 c1, u8 c2, u8 c3, u8 c4) ;


u32 GBK_24_GetData (unsigned char c1, unsigned char c2,u8 *temp) ;
void gt_16_GetData (u8 MSB,u8 LSB,u8 *temp);
void Uncompress(unsigned char *des,unsigned char *src);
void gt_12_GetData (u8 MSB,u8 LSB,u8 *temp);
u8  ASCII_GetData(u8 asc,u32 BaseAdd,u8 *temp);

#endif

