/*******************************************************************************
 *   adc.c
 *     ADɼNTC¶ȼ
 *     a288ˮ
 * ʵƽ̨a288 ԭͼ汾V1.0
 *     أSH79F1612A
 *     ߣliuyong
 * ޸ʱ䣺2016-03-25
*******************************************************************************/

#include "adc.h"
#include "disp_menu.h"

u8 Ntc_Fault_Flag = 0;


//NTCڵ
const u16 Temperature_Table[101] =
{
	3975,3968,3960,3952,3944,3936,3929,3922,3915,3907,//0~9
	3901,3891,3882,3872,3862,3852,3841,3829,3818,3806,//10~19
	3793,3780,3767,3753,3739,3724,3709,3693,3678,3661,//20~29
	3644,3627,3609,3590,3571,3551,3532,3511,3491,3469,//30~39
	3448,3425,3402,3379,3355,3331,3305,3280,3254,3227,//40~49
	3204,3173,3145,3117,3089,3060,3030,3001,2971,2941,//50~59	
	2910,2880,2849,2818,2787,2755,2723,2691,2659,2626,//60~69
	2593,2561,2529,2496,2464,2432,2397,2363,2329,2295,//70~79
	2261,2227,2194,2161,2128,2094,2062,2029,1996,1964,//80~89
	1932,1899,1867,1836,1804,1773,1743,1713,1683,1654,//90~99
	1625                                              //100
};

/*******************************************************************************
 * : void  Adc_Init(void)
 * : ADCʼ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/															   
void  Adc_Init(void)
{ 	
	ADC_InitTypeDef ADC_InitStructure; 
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_ADC1,ENABLE );	  //ʹADC1ͨʱ
 
	RCC_ADCCLKConfig(RCC_PCLK2_Div6);   //72M/6=12,ADCʱ䲻ܳ14M
	//PA0                    
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;		//ģ
	GPIO_Init(GPIOA,&GPIO_InitStructure);	

	ADC_DeInit(ADC1);  // ADC1 ȫĴΪȱʡֵ

	ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;	//ADCģʽ:ADC1ڶģʽ
	ADC_InitStructure.ADC_ScanConvMode = ENABLE;	//ģתڵͨģʽ
	ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;	//ģתڵתģʽ
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;	//תⲿ
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;	//ADCҶ
	ADC_InitStructure.ADC_NbrOfChannel = 1;	//˳йתADCͨĿ
	ADC_Init(ADC1, &ADC_InitStructure);	//ADC_InitStructָĲʼADCxļĴ   
 
	ADC_Cmd(ADC1,ENABLE);	//ʹָADC1
	
	ADC_ResetCalibration(ADC1);	//ָADC1У׼Ĵ
	 
	while(ADC_GetResetCalibrationStatus(ADC1));	//ȡADC1У׼Ĵ״̬,״̬ȴ
	
	ADC_StartCalibration(ADC1);		//ʼָADC1У׼״̬
 
	while(ADC_GetCalibrationStatus(ADC1));		//ȡָADC1У׼,״̬ȴ
 
	ADC_SoftwareStartConvCmd(ADC1, ENABLE);		//ʹָADC1ת

}	

/*******************************************************************************
 * : u16 Get_Adc(u8 ch)   
 * : ȡADCתֵ
 * β: ADC_channelתͨ
 * : 
 * ˵: 
 ******************************************************************************/
static u16 Get_Adc(u8 ch)   
{
  	//ָADCĹͨǵת˳Ͳʱ
	ADC_RegularChannelConfig(ADC1,ch,1,ADC_SampleTime_239Cycles5 );	//ADC1,ADCͨ3,˳ֵΪ1,ʱΪ239.5	  			    
  
	ADC_SoftwareStartConvCmd(ADC1, ENABLE);		//ʹָADC1ת	
	 
	while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC ));//ȴת

	return ADC_GetConversionValue(ADC1);	//һADC1ת
}

/*******************************************************************************
 * : void ADC_GetConversionValue(void)
 * : ȡADתֵתֵתʵ¶ֵ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
void ADC_GetConversionValue1(void)
{
	static u16 adc_temp = 0;//ADֵ
	static u8 adc_times = 0;  //

	if(adc_times == 0)
	{
		adc_temp = Get_Adc(ADC_Channel_0);
		adc_temp = 0;//һβɼADֵ
	}
	else
	{
		adc_temp += Get_Adc(ADC_Channel_0);
	}	
	adc_times++;
	
	if(adc_times > 8)
	{
		adc_times = 0;
		adc_temp = adc_temp >> 3;
		
		if(adc_temp > 4090)//NTC·
		{
			Ntc_Fault_Flag = 1;
		}
		else if(adc_temp > 20)
		{
			DHT_Dat[2] = GetTemp_Process(adc_temp);
			
			Ntc_Fault_Flag = 0;
		}
		else//NTC·
		{
			Ntc_Fault_Flag = 1;
		}
	}
}

/*******************************************************************************
 * : static INT8U GetTemp_Process(INT16U temp_adcvalue)
 * : ¶ֵȡ
 * β: temp_adcvalue¶ȴADֵ
 * : 
 * ˵:  
 ******************************************************************************/
static u8 GetTemp_Process(u16 temp_adcvalue)
{
	u8 temp_num = 0;
	u8 temp_buf = 0;

	if(temp_adcvalue > 3975)
	{
		temp_buf = 0;
	}
	else if(temp_adcvalue > 1625)
	{
		for(temp_num = 0;temp_num < 100;temp_num++)
		{
			if((temp_adcvalue >= Temperature_Table[temp_num + 1]) && (temp_adcvalue < Temperature_Table[temp_num]))
			{
				temp_buf = temp_num;

				break;
			}
		}
	}
	else
	{
		temp_buf = 100;
	}
	
	return temp_buf;
}

