/*******************************************************************************
 *   beep.c
 *     
 *     a288ˮ
 * ʵƽ̨a288 ԭͼ汾V1.0
 *     أSH79F1612A
 *     ߣliuyong
 * ޸ʱ䣺2016-03-25
*******************************************************************************/

#include "beep.h"

static u8 Beep_Start_Flag = 0;//ʼ־

static u8 Beep_Tweet_Value = 0;//д
static u16 Beep_Speak_Tmr = 0;//ʱ
static u8 Beep_Status = 0;//״̬
static u8 Beep_Tweet_Cnt = 0;//д
static u16 Beep_Tweet_TimeValue = 0;//ʱ䳤̱

static u8 Beep_Tweet_Flag = 0;

void Beep_Init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC,ENABLE);	 //ʹPC˿ʱ

    GPIO_ResetBits(GPIOC,GPIO_Pin_1);	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		 //IOٶΪ50MHz
	GPIO_Init(GPIOC, &GPIO_InitStructure);					    
}

void Beep_Speaker(void)
{
	if(Beep_Tweet_Flag)
	{
		BEEP_Reverse();
	}
}

/*******************************************************************************
 * : void Beep_Control1(void)
 * : Դƺ1
 * β: 
 * : 
 * ˵: 10msµãÿ0.5sͣ0.5s
 ******************************************************************************/
void Beep_Control1(void)
{
	if(Beep_Start_Flag == 1)
	{
		switch(Beep_Status)
		{
			case 0:
			{
				if(++Beep_Speak_Tmr > Beep_Tweet_TimeValue)
				{
					Beep_Speak_Tmr = 0;
					
					Beep_Tweet_Flag = 0;
					BEEP_OFF();
            
					Beep_Status++;
				}
				else 
				{
					Beep_Tweet_Flag = 1;
				}
			}
			break;
			case 1:
			{
				if(++Beep_Speak_Tmr > 49)
				{
					Beep_Speak_Tmr = 0;
					Beep_Tweet_Cnt++;
					if(Beep_Tweet_Cnt >= Beep_Tweet_Value)
					{//ﵽд

						if(Beep_Start_Flag == 1)
						{
							Beep_Start_Flag = 0;
						}
					}
					else
					{
						Beep_Status = 0;
					}
				}
			}
			break;
			default :
			break;
		}
	}
}

void Beep_Start_Init(u8 start_flag)
{
	Beep_Start_Flag = start_flag;
	Beep_Tweet_Flag = start_flag;
}

/*******************************************************************************
 * : void BeepVariable1_Init(INT8U Tweet_times)
 * : бʼ
 * β: Tweet_timesд
         Tweet_time : ʱ
 * : 
 * ˵: 
 ******************************************************************************/
void BeepVariable1_Init(u8 Tweet_times,u16 Tweet_time)
{
	Beep_Start_Init(1);
	Beep_Status = 0;
	Beep_Speak_Tmr = 0;
	Beep_Tweet_Cnt = 0;
	Beep_Tweet_Value = Tweet_times;
	Beep_Tweet_TimeValue = Tweet_time - 1;
}

