#ifndef  __PCF8563_H__
#define  __PCF8563_H__

#include "sys.h"

//ʱṹ
typedef struct 
{
	vu16 w_year;
	vu8  w_month;
    vu8  w_day;
	vu8 hour;
	vu8 min;
	vu8 sec;		
	vu8  week;		 
}_calendar_obj;		

//ũڽṹ
typedef struct 
{
	vu16 w_year;
	vu8  w_month;
    vu8  w_day;	 
}_chinacalendar_obj;		

extern _chinacalendar_obj chinacalendar;
extern _calendar_obj calendar;	//ṹ

#define WD_DADR	 0xA2	//write device-address 
#define RD_DADR	 0xA3	//read device-address

#define CTRL_BUF1	 0x00///״̬Ĵ1
#define CTRL_BUF2	 0x01///״̬Ĵ2

#define SECOND_DATA_BUF	0x02//Ĵ
#define MINUTE_DATA_BUF	0x03//ּĴ
#define HOUR_DATA_BUF	0x04//ʱĴ

#define DAY_DATA_BUF	0x05//ռĴ
#define WEEK_DATA_BUF	0x06//ڼĴ
#define MONTH_DATA_BUF	0x07//¼Ĵ
#define YEAR_DATA_BUF	0x08//Ĵ

#define MINUTE_AE_BUF	 0x09//ӱĴ
#define HOUR_AE_BUF	 0x0A//СʱĴ
#define DAY_AE_BUF	 0x0B//ձĴ
#define WEEK_AE_BUF	 0x0C//ڱĴ

#define CLK_FRQ_BUF	 0x0D//CLKOUTƵʼĴ
#define TIMER_CTRL_BUF	 0x0E//ʱƼĴ
#define COUNT_VAL_BUF	 0x0F//ʱֵĴ

//changeIntToHex33return 0x33
//αΪ unsigned 
#define changeDecToHex(dec)	 ((((dec)/10) <<4 ) + ((dec)%10))//ʮתʮ

//changeHexToInt0x33return 33
//αΪ unsigned 
#define changeHexToDec(hex)	 ((((hex)>>4) *10 ) + ((hex)%16))//ʮתʮ

extern u8 time_buf[3];//time_buf[0]룻time_buf[1]֣time_buf[2]ʱ

u8 PCF8563_WriteOneByte(u8 addr,u8 dat);
u8 PCF8563_WriteOneByteStr(u8 addr,u8 *s,u8 num);
u8 PCF8563_ReadOneByte(u8 ReadAddr,u8 *Dat);
u8 PCF8563_ReadOneByteStr(u8 ReadAddr,u8 *s,u8 num);
u8 PCF8563_GetTime(_calendar_obj *datetime);
u8 PCF8563_SetTime(_calendar_obj *datetime);
u8 PCF8563_Init(void);
void PCF8563_TimeInit(void);

#endif
