#include "delay.h"
#include "usart.h"
#include "led.h"
#include "GT30L24A3W.h"
#include "spi.h"
#include "timer.h"
#include "pcf8563.h"
#include "remote.h"
#include "led_16x32.h"
#include "zimo.h"
#include "key.h"
#include "myiic.h"
#include "stmflash.h"
#include "YF017.h"
#include "disp_menu.h"
#include "calendar.h"
#include "string.h"
#include "adc.h"

//ʪݣʪСݣ¶ݣ¶С
u8 DHT_Dat[4] = {0,0,0,0};

u8 DataBuf[8] = {0,0,0};//ũXXXXXֿеıλλ
u8 Zodiac_Num[2] = {0};//Фֿеλ
//SolarTerms_Num[6]Ч
u8 SolarTerms_Num[8] = {0,0,0};

u8 speed = 0;//ƶٶȿƱ
u8 speed_cnt = 0;//ƶٶȼ
u8 row_cnt = 0;//м
u16 bytes_cnt = 0;//ֽڼ
u32 row_value = 0x80000000;
u16 disp_switch_cnt = 0;//ʾл

u8 day_buf = 0;

char *LunarCalendar_Str = NULL;//йַ
char *SolarCalendar_Str = NULL;//ַ
u8 LunarCalendar_Num[10] = {0,0,0,0};//ַֿеλ
u8 SolarCalendar_Num[10] = {0,0,0,0};//ַֿеλ

u8 Lunar_Festival_Flag = 0;//ʾ־
u8 Solar_Festival_Flag = 0;//ʾ־

static void InitInformation_Disp(void);
static void CurrTime_Disp(void);
static void SolarDataLeft_Disp(void);
static void LunarDataLeft_Disp(void);
static void TempHumiLeft_Disp(void);
static void TimeDataSetLeft_Disp(u8 byte_num1,u8 byte_num2);
static void YearSet_Disp(void);
static void AllSet_Disp(u8 Byte_Num,u8 disp_dat);
static void SolarTermsLeft_Disp(void);
static void Lunar_Festival_Disp(void);
static void Solar_Festival_Disp(void);

void Clear_DatBuf(u8 *str)
{
    u8 i = 0;
    
    for(i = 0;i < 10;i++)
    {
        str[i] = 0;
    }
}
///*******************************************************************************
// * : u8 FindStrZero_Process(u8 *str)
// * : һԪ1ʼֵĵһ0ֵǵڼԪ
// * β: 
// * : 
// * ˵:  
// ******************************************************************************/
//u8 FindStrZero_Process(u8 *str)
//{
//    u8 i = 0;
//    u8 recv = 0;
//    
//    for(i = 1;i < 10;i++)
//    {
//        if(str[i] == 0)
//        {
//            recv = i;
//            break;
//        }
//    }
//    
//    return recv;
//}

/*******************************************************************************
 * : void DispVari_Init(void)
 * : ʾʼ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
void DispVari_Init(void)
{
    day_buf = 0;
    speed_cnt = 0;
    row_cnt = 0;
    bytes_cnt = 0;
    row_value = 0x80000000; 
    disp_switch_cnt = 0;
    Disp_Flicker_Flag = 0xff;
}

/*******************************************************************************
 * : void Disp_Process(void)
 * : ʾ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
void Disp_Process(void)
{
    switch(Function_Value)
    {
        case 0://ϵʾϢ
        {
            InitInformation_Disp();
        }
        break;
        
        case 1://ʾǰʱ
        {
            CurrTime_Disp();    
        }
        break;
        
        case 2://ʾ
        {
            SolarDataLeft_Disp();
        }
        break;
        
        case 3://ʪʾ
        {
            TempHumiLeft_Disp();
        }
        break;
        
        case 4://áʾ
        {
            TimeDataSetLeft_Disp(6,8);
        }
        break;
        
        case 5://
        {
            YearSet_Disp();
        }
        break;
        
        case 6://
        {
            AllSet_Disp(5,calendar.w_month);
        }
        break;
        
        case 7://
        {
            AllSet_Disp(6,calendar.w_day);
        }
        break;
        
        case 8://ʱáʾ
        {
            TimeDataSetLeft_Disp(22,23);
        }
        break;
        
        case 9://Сʱ
        {
            AllSet_Disp(22,calendar.hour);
        }
        break;
        
        case 10://
        {
            AllSet_Disp(24,calendar.min);
        }
        break;
        
        case 11://ƶʾ
        {
            SolarTermsLeft_Disp();
        }
        break;
        
        case 12://Ϣʾ
        {
            if(Lunar_Festival_Flag)
            {
                Lunar_Festival_Disp();
            }
            else
            {
                Function_Value = 1;
                speed = SPEED_0;
            }
        }
        break;
        
        case 13://ʾ
        {
            LunarDataLeft_Disp();
        }
        break;
        
        case 14://Ϣʾ
        {
            if(Solar_Festival_Flag)
            {
                Solar_Festival_Disp();
            }
            else
            {
                Function_Value = 1;
                speed = SPEED_0;
            }
        }
        break;
        
//        case 15:
//        {
//            Out_Abyte_595(0x00,0x00);
//            
//            if(row_cnt == 0)
//            {
//                DAT_164 = 0;
//            }
//            else
//            {
//                DAT_164 = 1;
//            }
//            
//            CLK_164 = 0;
//            CLK_164 = 1;
//            
//            if(row_cnt < 7)
//            {
//                Out_Abyte_595(0xff,0xff);
//            }
//            else if(row_cnt < 14)
//            {
//                Out_Abyte_595(0xff,0xff);
//            }
//            else if(row_cnt < 18)
//            {                   
//                Out_Abyte_595(0xff,0xff);
//            }
//            else if(row_cnt < 25)
//            {
//                Out_Abyte_595(0xff,0xff);
//            }
//            else if(row_cnt < 32)
//            {
//                Out_Abyte_595(0xff,0xff);
//            }
//                
//            row_cnt++;
//            if(row_cnt < 32)
//            {
//                row_value >>= 1;
//            }
//            else
//            {
//                row_cnt = 0;
//                row_value = 0x80000000;
//            }        
//        }
//        break;
        
        default :
            break;
    }
}

/*******************************************************************************
 * : static void Solar_Festival_Disp(void)
 * : Ϣʾ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
static void Solar_Festival_Disp(void)
{
    u16 left_cnt = 0;
    u8 byte_num = 0;
    
    byte_num = strlen(SolarCalendar_Str)/2;
    
    left_cnt = byte_num*32;
    
    Out_Abyte_595(0x00,0x00);
    
    if(row_cnt == 0)
    {
        DAT_164 = 0;
    }
    else
    {
        DAT_164 = 1;
    }
    
    CLK_164 = 0;
    CLK_164 = 1;
    
    if((2*(row_cnt+bytes_cnt)+1) < 32)
    {
        Out_Abyte_595(codeGB_16[SolarCalendar_Num[1]].Msk[2*(row_cnt+bytes_cnt)],codeGB_16[SolarCalendar_Num[1]].Msk[2*(row_cnt+bytes_cnt)+1]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 64)
    {
        Out_Abyte_595(codeGB_16[SolarCalendar_Num[2]].Msk[2*(row_cnt+bytes_cnt-16)],codeGB_16[SolarCalendar_Num[2]].Msk[2*(row_cnt+bytes_cnt-16)+1]);
    }   
    else if((2*(row_cnt+bytes_cnt)+1) < 96)
    {
        Out_Abyte_595(codeGB_16[SolarCalendar_Num[3]].Msk[2*(row_cnt+bytes_cnt-32)],codeGB_16[SolarCalendar_Num[3]].Msk[2*(row_cnt+bytes_cnt-32)+1]);
    }   
    else if((2*(row_cnt+bytes_cnt)+1) < 128)
    {
        Out_Abyte_595(codeGB_16[SolarCalendar_Num[4]].Msk[2*(row_cnt+bytes_cnt-48)],codeGB_16[SolarCalendar_Num[4]].Msk[2*(row_cnt+bytes_cnt-48)+1]);
    }   
    else if((2*(row_cnt+bytes_cnt)+1) < 160)
    {
        if(byte_num >= 5)
        {
            Out_Abyte_595(codeGB_16[SolarCalendar_Num[5]].Msk[2*(row_cnt+bytes_cnt-64)],codeGB_16[SolarCalendar_Num[5]].Msk[2*(row_cnt+bytes_cnt-64)+1]);
        }
        else
        {
            Out_Abyte_595(0x00,0x00);
        }
    }  
    else if((2*(row_cnt+bytes_cnt)+1) < 192)
    {
        if(byte_num >= 6)
        {
            Out_Abyte_595(codeGB_16[SolarCalendar_Num[6]].Msk[2*(row_cnt+bytes_cnt-80)],codeGB_16[SolarCalendar_Num[6]].Msk[2*(row_cnt+bytes_cnt-80)+1]);
        }
        else
        {
            Out_Abyte_595(0x00,0x00);
        }
    }  
    else if((2*(row_cnt+bytes_cnt)+1) < 224)
    {
        if(byte_num >= 7)
        {
            Out_Abyte_595(codeGB_16[SolarCalendar_Num[7]].Msk[2*(row_cnt+bytes_cnt-96)],codeGB_16[SolarCalendar_Num[7]].Msk[2*(row_cnt+bytes_cnt-96)+1]);
        }
        else
        {
            Out_Abyte_595(0x00,0x00);
        }
    }   
    else if((2*(row_cnt+bytes_cnt)+1) < 256)
    {
        if(byte_num >= 8)
        {
            Out_Abyte_595(codeGB_16[SolarCalendar_Num[8]].Msk[2*(row_cnt+bytes_cnt-112)],codeGB_16[SolarCalendar_Num[8]].Msk[2*(row_cnt+bytes_cnt-112)+1]);
        }
        else
        {
            Out_Abyte_595(0x00,0x00);
        }
    }  
    else if((2*(row_cnt+bytes_cnt)+1) < 288)
    {
        if(byte_num >= 9)
        {
            Out_Abyte_595(codeGB_16[SolarCalendar_Num[9]].Msk[2*(row_cnt+bytes_cnt-128)],codeGB_16[SolarCalendar_Num[9]].Msk[2*(row_cnt+bytes_cnt-128)+1]);
        }
        else
        {
            Out_Abyte_595(0x00,0x00);
        }
    }       
    else
    {
        Out_Abyte_595(0x00,0x00);
    }        
    
    row_cnt++;
    if(row_cnt < 32)
    {
        row_value >>= 1;
    }
    else
    {
        row_cnt = 0;
        row_value = 0x80000000;
        speed_cnt++;
        if(speed_cnt > speed)
        {
            speed_cnt = 0;
            bytes_cnt++; 
            
            if((2*(row_cnt+bytes_cnt)+1) > left_cnt)
            {
                bytes_cnt = 0;
                CLR_164 = 0;
                delay_us(10);
                CLR_164 = 1;
                Function_Value = 1;
                speed = SPEED_0;
            }
        }
    }     
}

/*******************************************************************************
 * : void Lunar_Festival_Disp(void)
 * : Ϣʾ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
static void Lunar_Festival_Disp(void)
{
    u16 left_cnt = 0;
    u8 byte_num = 0;
    
    byte_num = strlen(LunarCalendar_Str)/2;
    
    left_cnt = byte_num*32;
    
    Out_Abyte_595(0x00,0x00);
    
    if(row_cnt == 0)
    {
        DAT_164 = 0;
    }
    else
    {
        DAT_164 = 1;
    }
    
    CLK_164 = 0;
    CLK_164 = 1;
    
    if((2*(row_cnt+bytes_cnt)+1) < 32)
    {
        Out_Abyte_595(codeGB_16[LunarCalendar_Num[1]].Msk[2*(row_cnt+bytes_cnt)],codeGB_16[LunarCalendar_Num[1]].Msk[2*(row_cnt+bytes_cnt)+1]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 64)
    {
        Out_Abyte_595(codeGB_16[LunarCalendar_Num[2]].Msk[2*(row_cnt+bytes_cnt-16)],codeGB_16[LunarCalendar_Num[2]].Msk[2*(row_cnt+bytes_cnt-16)+1]);
    }   
    else if((2*(row_cnt+bytes_cnt)+1) < 96)
    {
        Out_Abyte_595(codeGB_16[LunarCalendar_Num[3]].Msk[2*(row_cnt+bytes_cnt-32)],codeGB_16[LunarCalendar_Num[3]].Msk[2*(row_cnt+bytes_cnt-32)+1]);
    }   
    else if((2*(row_cnt+bytes_cnt)+1) < 128)
    {
        Out_Abyte_595(codeGB_16[LunarCalendar_Num[4]].Msk[2*(row_cnt+bytes_cnt-48)],codeGB_16[LunarCalendar_Num[4]].Msk[2*(row_cnt+bytes_cnt-48)+1]);
    }   
    else if((2*(row_cnt+bytes_cnt)+1) < 160)
    {
        Out_Abyte_595(codeGB_16[LunarCalendar_Num[5]].Msk[2*(row_cnt+bytes_cnt-64)],codeGB_16[LunarCalendar_Num[5]].Msk[2*(row_cnt+bytes_cnt-64)+1]);
    }  
    else if((2*(row_cnt+bytes_cnt)+1) < 192)
    {
        if(byte_num >= 6)
        {
            Out_Abyte_595(codeGB_16[LunarCalendar_Num[6]].Msk[2*(row_cnt+bytes_cnt-80)],codeGB_16[LunarCalendar_Num[6]].Msk[2*(row_cnt+bytes_cnt-80)+1]);
        }
        else
        {
            Out_Abyte_595(0x00,0x00);
        }
    }  
    else if((2*(row_cnt+bytes_cnt)+1) < 224)
    {
        if(byte_num >= 7)
        {
            Out_Abyte_595(codeGB_16[LunarCalendar_Num[7]].Msk[2*(row_cnt+bytes_cnt-96)],codeGB_16[LunarCalendar_Num[7]].Msk[2*(row_cnt+bytes_cnt-96)+1]);
        }
        else
        {
            Out_Abyte_595(0x00,0x00);
        }
    }   
    else if((2*(row_cnt+bytes_cnt)+1) < 256)
    {
        if(byte_num >= 8)
        {
            Out_Abyte_595(codeGB_16[LunarCalendar_Num[8]].Msk[2*(row_cnt+bytes_cnt-112)],codeGB_16[LunarCalendar_Num[8]].Msk[2*(row_cnt+bytes_cnt-112)+1]);
        }
        else
        {
            Out_Abyte_595(0x00,0x00);
        }
    }        
    else
    {
        Out_Abyte_595(0x00,0x00);
    }        
    
    row_cnt++;
    if(row_cnt < 32)
    {
        row_value >>= 1;
    }
    else
    {
        row_cnt = 0;
        row_value = 0x80000000;
        speed_cnt++;
        if(speed_cnt > speed)
        {
            speed_cnt = 0;
            bytes_cnt++; 
            
            if((2*(row_cnt+bytes_cnt)+1) > left_cnt)
            {
                bytes_cnt = 0;
                CLR_164 = 0;
                delay_us(10);
                CLR_164 = 1;
                Function_Value = 1;
                speed = SPEED_0;
            }
        }
    }     
}

/*******************************************************************************
 * : static void SolarTermsLeft_Disp(void)
 * : ʾ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
static void SolarTermsLeft_Disp(void)
{
    u8 left_cnt = 0;
    
    Out_Abyte_595(0x00,0x00);
    
    if(row_cnt == 0)
    {
        DAT_164 = 0;
    }
    else
    {
        DAT_164 = 1;
    }
    
    CLK_164 = 0;
    CLK_164 = 1;
    
    if(SolarTerms_Flag == 2)
    {
        if((2*(row_cnt+bytes_cnt)+1) < 32)
        {
            Out_Abyte_595(codeGB_16[85].Msk[2*(row_cnt+bytes_cnt)],codeGB_16[85].Msk[2*(row_cnt+bytes_cnt)+1]);
        }
        else if((2*(row_cnt+bytes_cnt)+1) < 64)
        {
            Out_Abyte_595(codeGB_16[84].Msk[2*(row_cnt+bytes_cnt-16)],codeGB_16[84].Msk[2*(row_cnt+bytes_cnt-16)+1]);
        }
        else if((2*(row_cnt+bytes_cnt)+1) < 96)
        {
            Out_Abyte_595(codeGB_16[86].Msk[2*(row_cnt+bytes_cnt-32)],codeGB_16[86].Msk[2*(row_cnt+bytes_cnt-32)+1]);
        }
        else if((2*(row_cnt+bytes_cnt)+1) < 128)
        {
            Out_Abyte_595(codeGB_16[SolarTerms_Num[1]].Msk[2*(row_cnt+bytes_cnt-48)],codeGB_16[SolarTerms_Num[1]].Msk[2*(row_cnt+bytes_cnt-48)+1]);
        }
        else if((2*(row_cnt+bytes_cnt)+1) < 160)
        {
            Out_Abyte_595(codeGB_16[SolarTerms_Num[2]].Msk[2*(row_cnt+bytes_cnt-64)],codeGB_16[SolarTerms_Num[2]].Msk[2*(row_cnt+bytes_cnt-64)+1]);
        }     
        else
        {
            Out_Abyte_595(0x00,0x00);
        }
    }
    else if(SolarTerms_Flag == 1)
    {
        if((2*(row_cnt+bytes_cnt)+1) < 32)
        {
            Out_Abyte_595(codeGB_16[SolarTerms_Num[1]].Msk[2*(row_cnt+bytes_cnt)],codeGB_16[SolarTerms_Num[1]].Msk[2*(row_cnt+bytes_cnt)+1]);
        }
        else if((2*(row_cnt+bytes_cnt)+1) < 64)
        {
            Out_Abyte_595(codeGB_16[SolarTerms_Num[2]].Msk[2*(row_cnt+bytes_cnt-16)],codeGB_16[SolarTerms_Num[2]].Msk[2*(row_cnt+bytes_cnt-16)+1]);
        }   
        else if((2*(row_cnt+bytes_cnt)+1) < 96)
        {
            Out_Abyte_595(codeGB_16[SolarTerms_Num[3]].Msk[2*(row_cnt+bytes_cnt-32)],codeGB_16[SolarTerms_Num[3]].Msk[2*(row_cnt+bytes_cnt-32)+1]);
        }   
        else if((2*(row_cnt+bytes_cnt)+1) < 128)
        {
            Out_Abyte_595(codeGB_16[SolarTerms_Num[4]].Msk[2*(row_cnt+bytes_cnt-48)],codeGB_16[SolarTerms_Num[4]].Msk[2*(row_cnt+bytes_cnt-48)+1]);
        }   
        else if((2*(row_cnt+bytes_cnt)+1) < 160)
        {
            Out_Abyte_595(codeGB_16[SolarTerms_Num[5]].Msk[2*(row_cnt+bytes_cnt-64)],codeGB_16[SolarTerms_Num[5]].Msk[2*(row_cnt+bytes_cnt-64)+1]);
        }   
        else if((2*(row_cnt+bytes_cnt)+1) < 176)
        {
            Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-80)+(SolarTerms[10]-0x30)*16],Num_Tab1[2*(row_cnt+bytes_cnt-80)+1+(SolarTerms[10]-0x30)*16]);        
        }  
        else if((2*(row_cnt+bytes_cnt)+1) < 192)
        {
            Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-88)+(SolarTerms[11]-0x30)*16],Num_Tab1[2*(row_cnt+bytes_cnt-88)+1+(SolarTerms[11]-0x30)*16]);        
        }  
        else if((2*(row_cnt+bytes_cnt)+1) < 224)
        {
            Out_Abyte_595(codeGB_16[SolarTerms_Num[7]].Msk[2*(row_cnt+bytes_cnt-96)],codeGB_16[SolarTerms_Num[7]].Msk[2*(row_cnt+bytes_cnt-96)+1]);
        }   
        else
        {
            Out_Abyte_595(0x00,0x00);
        }        
    }
    
    row_cnt++;
    if(row_cnt < 32)
    {
        row_value >>= 1;
    }
    else
    {
        row_cnt = 0;
        row_value = 0x80000000;
        speed_cnt++;
        if(speed_cnt > speed)
        {
            speed_cnt = 0;
            bytes_cnt++;
            
            if(SolarTerms_Flag == 2)
            {
                left_cnt = 160;
            }
            else if(SolarTerms_Flag == 1)
            {
                left_cnt = 224;
            }   
            
            if((2*(row_cnt+bytes_cnt)+1) > left_cnt)
            {
                bytes_cnt = 0;
                CLR_164 = 0;
                delay_us(10);
                CLR_164 = 1;
                Function_Value = 1;
                speed = SPEED_0;
            }
        }
    } 
}

/*******************************************************************************
 * : static void AllSet_Disp(void)
 * : ʱùú
 * β: Byte_Num:ʾĺֿеƫ
         disp_dat:Ҫʾ
 * : 
 * ˵:  
 ******************************************************************************/
static void AllSet_Disp(u8 Byte_Num,u8 disp_dat)
{
    Out_Abyte_595(0x00,0x00);
    
    if(row_cnt == 0)
    {
        DAT_164 = 0;
    }
    else
    {
        DAT_164 = 1;
    }
    
    CLK_164 = 0;
    CLK_164 = 1;
    
    if(row_cnt < 16)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt)+Byte_Num*32],CH_16X16[2*(row_cnt)+1+Byte_Num*32]);
    }
    else if(row_cnt < 24)
    {
        if(Disp_Flicker_Flag)
        {
            Out_Abyte_595(Num_Tab1[2*(row_cnt-16)+(disp_dat/10)*16],Num_Tab1[2*(row_cnt-16)+1+(disp_dat/10)*16]);
        }
        else
        {
            Out_Abyte_595(0x00,0x00);
        }
    }
    else if(row_cnt < 32)
    {
        if(Disp_Flicker_Flag)
        {
            Out_Abyte_595(Num_Tab1[2*(row_cnt-24)+(disp_dat%10)*16],Num_Tab1[2*(row_cnt-24)+1+(disp_dat%10)*16]);
        }
        else
        {
            Out_Abyte_595(0x00,0x00);
        }
    }
    else
    {
        Out_Abyte_595(0x00,0x00);
    }
    
    row_cnt++;
    if(row_cnt < 32)
    {
        row_value >>= 1;
    }
    else
    {
        row_cnt = 0;
        row_value = 0x80000000;
    }     
}

/*******************************************************************************
 * : static void YearSet_Disp(void)
 * : ʾ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
static void YearSet_Disp(void)
{
    Out_Abyte_595(0x00,0x00);
    
    if(row_cnt == 0)
    {
        DAT_164 = 0;
    }
    else
    {
        DAT_164 = 1;
    }
    
    CLK_164 = 0;
    CLK_164 = 1;
    
    if(row_cnt < 8)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt)+(calendar.w_year/1000)*16],Num_Tab1[2*(row_cnt)+1+(calendar.w_year/1000)*16]);
    }
    else if(row_cnt < 16)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt-8)+((calendar.w_year%1000)/100)*16],Num_Tab1[2*(row_cnt-8)+1+((calendar.w_year%1000)/100)*16]);
    }
    else if(row_cnt < 24)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt-16)+(((calendar.w_year%1000)%100)/10)*16],Num_Tab1[2*(row_cnt-16)+1+(((calendar.w_year%1000)%100)/10)*16]);
    }
    else if(row_cnt < 32)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt-24)+(((calendar.w_year%1000)%100)%10)*16],Num_Tab1[2*(row_cnt-24)+1+(((calendar.w_year%1000)%100)%10)*16]);
    }
    else
    {
        Out_Abyte_595(0x00,0x00);
    }
    
    row_cnt++;
    if(row_cnt < 32)
    {
        row_value >>= 1;
    }
    else
    {
        row_cnt = 0;
        row_value = 0x80000000;
    }     
}

/*******************************************************************************
 * : static void DataSet_Disp(void)
 * : ""ߡʱáʾ
 * β: byte_num1:աߡʱֿеƫ
         byte_num1:ڡߡ䡱ֿеƫ
 * : 
 * ˵:  
 ******************************************************************************/
static void TimeDataSetLeft_Disp(u8 byte_num1,u8 byte_num2)
{
    Out_Abyte_595(0x00,0x00);
    
    if(row_cnt == 0)
    {
        DAT_164 = 0;
    }
    else
    {
        DAT_164 = 1;
    }
    
    CLK_164 = 0;
    CLK_164 = 1;
    
    if((2*(row_cnt+bytes_cnt)+1) < 32)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt)+byte_num1*32],CH_16X16[2*(row_cnt+bytes_cnt)+1+byte_num1*32]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 64)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt-16)+byte_num2*32],CH_16X16[2*(row_cnt+bytes_cnt-16)+1+byte_num2*32]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 128)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt-32)+20*32],CH_16X16[2*(row_cnt+bytes_cnt-32)+1+20*32]);
    }
    else
    {
        Out_Abyte_595(0x00,0x00);
    }
    
    row_cnt++;
    if(row_cnt < 32)
    {
        row_value >>= 1;
    }
    else
    {
        row_cnt = 0;
        row_value = 0x80000000;
        speed_cnt++;
        if(speed_cnt > speed)
        {
            speed_cnt = 0;
            bytes_cnt++;
            
            if((2*(row_cnt+bytes_cnt)+1) > 128)
            {
                bytes_cnt = 0;
                CLR_164 = 0;
                delay_us(10);
                CLR_164 = 1;
                if(Function_Value == 4)
                {
                    Function_Value = 5;
                }
                else if(Function_Value == 8)
                {
                    Function_Value = 9;
                }
            }
        }
    }    
}

/*******************************************************************************
 * : static void InitInformation_Disp(void)
 * : ϵʼϢʾ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
static void InitInformation_Disp(void)
{
    speed = 3;
    
    Out_Abyte_595(0x00,0x00);
    
    if(row_cnt == 0)
    {
        DAT_164 = 0;
    }
    else
    {
        DAT_164 = 1;
    }
    
    CLK_164 = 0;
    CLK_164 = 1;
    
    if((2*(row_cnt+bytes_cnt)+1) < 512)
    {
        Out_Abyte_595(Logo[2*(row_cnt+bytes_cnt)],Logo[2*(row_cnt+bytes_cnt)+1]);
    }
    else
    {
        Out_Abyte_595(0x00,0x00);
    }
    
    row_cnt++;
    if(row_cnt < 32)
    {
        row_value >>= 1;
    }
    else
    {
        row_cnt = 0;
        row_value = 0x80000000;
        speed_cnt++;
        if(speed_cnt > speed)
        {
            speed_cnt = 0;
            bytes_cnt++;
            
            if((2*(row_cnt+bytes_cnt)+1) > 511)
            {
                bytes_cnt = 0;
                CLR_164 = 0;
                delay_us(10);
                CLR_164 = 1;
                Function_Value = 1;
                speed = SPEED_0;
            }
        }
    }     
}

/*******************************************************************************
 * : static void CurrTime_Disp(void)
 * : ǰʱʾ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
static void CurrTime_Disp(void)
{
    Out_Abyte_595(0x00,0x00);
    
    if(row_cnt == 0)
    {
        DAT_164 = 0;
    }
    else
    {
        DAT_164 = 1;
    }
    
    CLK_164 = 0;
    CLK_164 = 1;
    
    if(row_cnt < 7)
    {
        Out_Abyte_595(Num_Tab[(2*row_cnt) + (calendar.hour/10)*14],Num_Tab[(2*row_cnt+1) + (calendar.hour/10)*14]);
    }
    else if(row_cnt < 14)
    {
        Out_Abyte_595(Num_Tab[(2*(row_cnt-7)) + (calendar.hour%10)*14],Num_Tab[(2*(row_cnt-7)+1) + (calendar.hour%10)*14]);
    }
    else if(row_cnt < 18)
    {                   
        if(Disp_Flicker_Flag == 1)
        {
            Out_Abyte_595(Time_Dot1[2*(row_cnt-14)],Time_Dot1[2*(row_cnt-14)+1]);
        }
        else
        {
            Out_Abyte_595(0X00,0X00);
        }
    }
    else if(row_cnt < 25)
    {
        Out_Abyte_595(Num_Tab[(2*(row_cnt-18)) + (calendar.min/10)*14],Num_Tab[(2*(row_cnt-18)+1) + (calendar.min/10)*14]);
    }
    else if(row_cnt < 32)
    {
        Out_Abyte_595(Num_Tab[(2*(row_cnt-25)) + (calendar.min%10)*14],Num_Tab[(2*(row_cnt-25)+1) + (calendar.min%10)*14]);
    }
        
    row_cnt++;
    if(row_cnt < 32)
    {
        row_value >>= 1;
    }
    else
    {
        row_cnt = 0;
        row_value = 0x80000000;
        
        if((calendar.hour > 5) && (calendar.hour < 21))//㵽21ſڵлʾ
        {
            disp_switch_cnt++;
            if(disp_switch_cnt == 3000)
            {
                Function_Value = 2;               
            }
            else if(disp_switch_cnt == 3300)
            {
                Function_Value = 13;
            }
            else if(disp_switch_cnt == 3600)
            {
                Function_Value = 3;
            }
            else if(disp_switch_cnt == 6600)
            {
                Function_Value = 11;
            }
            else if(disp_switch_cnt == 6900)
            {
                Function_Value = 12;
            }
            else if(disp_switch_cnt == 7200)
            {
                disp_switch_cnt = 0;
                Function_Value = 14;
            }
        }
        else
        {
            disp_switch_cnt = 0;
        }
    }     
}

/*******************************************************************************
 * : static void LunarDataLeft_Disp(void)
 * : ʾ
 * β: 
 * : 
 * ˵:  
******************************************************************************/
static void LunarDataLeft_Disp(void)
{
    Out_Abyte_595(0x00,0x00);
    
    if(row_cnt == 0)
    {
        DAT_164 = 0;
    }
    else
    {
        DAT_164 = 1;
    }
    
    CLK_164 = 0;
    CLK_164 = 1;
    
    if((2*(row_cnt+bytes_cnt)+1) < 64)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt)+25*32],CH_16X16[2*(row_cnt+bytes_cnt)+1+25*32]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 96)
    {
        Out_Abyte_595(codeGB_16[DataBuf[1]].Msk[2*(row_cnt+bytes_cnt-32)],codeGB_16[DataBuf[1]].Msk[2*(row_cnt+bytes_cnt-32)+1]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 128)
    {
        Out_Abyte_595(codeGB_16[DataBuf[2]].Msk[2*(row_cnt+bytes_cnt-48)],codeGB_16[DataBuf[2]].Msk[2*(row_cnt+bytes_cnt-48)+1]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 160)
    {
        Out_Abyte_595(codeGB_16[DataBuf[3]].Msk[2*(row_cnt+bytes_cnt-64)],codeGB_16[DataBuf[3]].Msk[2*(row_cnt+bytes_cnt-64)+1]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 192)
    {
        Out_Abyte_595(codeGB_16[DataBuf[4]].Msk[2*(row_cnt+bytes_cnt-80)],codeGB_16[DataBuf[4]].Msk[2*(row_cnt+bytes_cnt-80)+1]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 224)
    {
        Out_Abyte_595(codeGB_16[DataBuf[5]].Msk[2*(row_cnt+bytes_cnt-96)],codeGB_16[DataBuf[5]].Msk[2*(row_cnt+bytes_cnt-96)+1]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 256)
    {
        Out_Abyte_595(codeGB_16[DataBuf[6]].Msk[2*(row_cnt+bytes_cnt-112)],codeGB_16[DataBuf[6]].Msk[2*(row_cnt+bytes_cnt-112)+1]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 288)
    {
        Out_Abyte_595(codeGB_16[DataBuf[7]].Msk[2*(row_cnt+bytes_cnt-128)],codeGB_16[DataBuf[7]].Msk[2*(row_cnt+bytes_cnt-128)+1]);
    }   
    else if((2*(row_cnt+bytes_cnt)+1) < 320)
    {
        Out_Abyte_595(codeGB_16[80].Msk[2*(row_cnt+bytes_cnt-144)],codeGB_16[80].Msk[2*(row_cnt+bytes_cnt-144)+1]);
    }   
    else if((2*(row_cnt+bytes_cnt)+1) < 352)
    {
        Out_Abyte_595(codeGB_16[Zodiac_Num[1]].Msk[2*(row_cnt+bytes_cnt-160)],codeGB_16[Zodiac_Num[1]].Msk[2*(row_cnt+bytes_cnt-160)+1]);
    } 
    else if((2*(row_cnt+bytes_cnt)+1) < 384)
    {
        Out_Abyte_595(codeGB_16[39].Msk[2*(row_cnt+bytes_cnt-176)],codeGB_16[39].Msk[2*(row_cnt+bytes_cnt-176)+1]);
    }  
    else
    {
        Out_Abyte_595(0x00,0x00);
    }
    
    row_cnt++;
    if(row_cnt < 32)
    {
        row_value >>= 1;
    }
    else
    {
        row_cnt = 0;
        row_value = 0x80000000;
        speed_cnt++;
        if(speed_cnt > speed)
        {
            speed_cnt = 0;
            bytes_cnt++;
            
            if((2*(row_cnt+bytes_cnt)+1) > 384)
            {
                bytes_cnt = 0;
                CLR_164 = 0;
                delay_us(10);
                CLR_164 = 1;
                Function_Value = 1;
                speed = SPEED_0;
            }
        }
    } 
}
/*******************************************************************************
 * : static void SolarDataLeft_Disp(void)
 * : ʾ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
static void SolarDataLeft_Disp(void)
{
    Out_Abyte_595(0x00,0x00);
    
    if(row_cnt == 0)
    {
        DAT_164 = 0;
    }
    else
    {
        DAT_164 = 1;
    }
    
    CLK_164 = 0;
    CLK_164 = 1;
    
    if((2*(row_cnt+bytes_cnt)+1) < 96)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt)+1*32],CH_16X16[2*(row_cnt+bytes_cnt)+1+1*32]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 112)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-48)+(calendar.w_year/1000)*16],Num_Tab1[2*(row_cnt+bytes_cnt-48)+1+(calendar.w_year/1000)*16]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 128)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-56)+((calendar.w_year%1000)/100)*16],Num_Tab1[2*(row_cnt+bytes_cnt-56)+1+((calendar.w_year%1000)/100)*16]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 144)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-64)+(((calendar.w_year%1000)%100)/10)*16],Num_Tab1[2*(row_cnt+bytes_cnt-64)+1+(((calendar.w_year%1000)%100)/10)*16]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 160)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-72)+(((calendar.w_year%1000)%100)%10)*16],Num_Tab1[2*(row_cnt+bytes_cnt-72)+1+(((calendar.w_year%1000)%100)%10)*16]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 192)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt-80)+4*32],CH_16X16[2*(row_cnt+bytes_cnt-80)+1+4*32]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 208)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-96)+(calendar.w_month/10)*16],Num_Tab1[2*(row_cnt+bytes_cnt-96)+1+(calendar.w_month/10)*16]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 224)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-104)+(calendar.w_month%10)*16],Num_Tab1[2*(row_cnt+bytes_cnt-104)+1+(calendar.w_month%10)*16]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 256)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt-112)+5*32],CH_16X16[2*(row_cnt+bytes_cnt-112)+1+5*32]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 272)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-128)+(calendar.w_day/10)*16],Num_Tab1[2*(row_cnt+bytes_cnt-128)+1+(calendar.w_day/10)*16]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 288)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-136)+(calendar.w_day%10)*16],Num_Tab1[2*(row_cnt+bytes_cnt-136)+1+(calendar.w_day%10)*16]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 384)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt-144)+6*32],CH_16X16[2*(row_cnt+bytes_cnt-144)+1+6*32]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 416)
    {
        if(calendar.week == 0)
        {
            Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt-192)+6*32],CH_16X16[2*(row_cnt+bytes_cnt-192)+1+6*32]);
        }
        else
        {
            Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt-192)+(calendar.week+8)*32],CH_16X16[2*(row_cnt+bytes_cnt-192)+1+(calendar.week+8)*32]);
        }
    }
    else
    {
        Out_Abyte_595(0x00,0x00);
    }
    
    row_cnt++;
    if(row_cnt < 32)
    {
        row_value >>= 1;
    }
    else
    {
        row_cnt = 0;
        row_value = 0x80000000;
        speed_cnt++;
        if(speed_cnt > speed)
        {
            speed_cnt = 0;
            bytes_cnt++;
            if((2*(row_cnt+bytes_cnt)+1) > 416)
            {
                bytes_cnt = 0;
                CLR_164 = 0;
                delay_us(10);
                CLR_164 = 1;
                Function_Value = 1;
                speed = SPEED_0;
            }
        }
    } 
}

/*******************************************************************************
 * : static void TempHumiLeft_Disp(void)
 * : ʪʾ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
static void TempHumiLeft_Disp(void)
{
    if(Ntc_Fault_Flag)
    {
        Function_Value = 1;
        DispVari_Init();
        return ;
    }
    
    Out_Abyte_595(0x00,0x00);
    
    if(row_cnt == 0)
    {
        DAT_164 = 0;
    }
    else
    {
        DAT_164 = 1;
    }
    
    CLK_164 = 0;
    CLK_164 = 1;
    

    if((2*(row_cnt+bytes_cnt)+1) < 32)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt)+17*32],CH_16X16[2*(row_cnt+bytes_cnt)+1+17*32]);
    }           
    else if((2*(row_cnt+bytes_cnt)+1) < 64)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt-16)+19*32],CH_16X16[2*(row_cnt+bytes_cnt-16)+1+19*32]);
    }                 
    else if((2*(row_cnt+bytes_cnt)+1) < 80)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-32)+11*16],Num_Tab1[2*(row_cnt+bytes_cnt-32)+1+11*16]);
    }           
    else if((2*(row_cnt+bytes_cnt)+1) < 96)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-40)+(DHT_Dat[2]/10)*16],Num_Tab1[2*(row_cnt+bytes_cnt-40)+1+(DHT_Dat[2]/10)*16]);
    }
    else if((2*(row_cnt+bytes_cnt)+1) < 112)
    {
        Out_Abyte_595(Num_Tab1[2*(row_cnt+bytes_cnt-48)+(DHT_Dat[2]%10)*16],Num_Tab1[2*(row_cnt+bytes_cnt-48)+1+(DHT_Dat[2]%10)*16]);
    }            
    else if((2*(row_cnt+bytes_cnt)+1) < 144)
    {
        Out_Abyte_595(CH_16X16[2*(row_cnt+bytes_cnt-56)],CH_16X16[2*(row_cnt+bytes_cnt-56)+1]);
    }                
    else
    {
        Out_Abyte_595(0x00,0x00);
    }
    
    row_cnt++;
    if(row_cnt < 32)
    {
        row_value >>= 1;
    }
    else
    {
        row_cnt = 0;
        row_value = 0x80000000;
        speed_cnt++;
        if(speed_cnt > speed)
        {
            speed_cnt = 0;
            bytes_cnt++;
            if((2*(row_cnt+bytes_cnt)+1) > 144)
            {
                bytes_cnt = 0;
                CLR_164 = 0;
                delay_us(10);
                CLR_164 = 1;
                Function_Value = 1;
                speed = SPEED_0;
            }
        }
    }     
}

/*******************************************************************************
 * : u8 GetHzInternalCode_Word(char c[2])
 * : ĳֿеλ
 * β: c[2]ѯĺ
 * : ظúֿеλ
 * ˵:  
 ******************************************************************************/
u8 GetHzInternalCode_Word(char *c)
{
	u8 k;
    u8 bytenum_buf = 0;

	for (k=0;k<142;k++) 
	{ //ʾԽֿеĸѭѯ
		if ((codeGB_16[k].Index[0]==c[0])&&(codeGB_16[k].Index[1]==c[1]))
		{ 	//
            bytenum_buf = k;
		}  
	 }	
    
     return bytenum_buf;
}

/*******************************************************************************
 * : void GetHzInternalCode_Str(u8 *num,char *s)
 * : ĳַкֿеλ
 * β: *numŷصλ
         sѯַ
         byte_num:ַжٸ
 * : 
 * ˵:  
 ******************************************************************************/
void GetHzInternalCode_Str(u8 *num,char *s,u8 byte_num)
{
    u8 bynum = 0;
    char Hz_Data[2];
    u8 i;
    
    for(i = 0;i < byte_num;i++)
    {
        Hz_Data[0] = s[2*i];
        Hz_Data[1] = s[2*i + 1];
        bynum = GetHzInternalCode_Word(Hz_Data);
        
        num[i+1] = bynum;
    }
    i = 0;
}

/*******************************************************************************
 * : void LunarCalendarFestival_Process(void)
 * : մ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
void LunarCalendarFestival_Process(void)
{
    _chinacalendar_obj chi_calendar_buf;
    
    if((chinacalendar.w_month == 12) && (chinacalendar.w_day == 29))
    {
        GetChinaCalendar(calendar.w_year,calendar.w_month,(calendar.w_day + 1),&chi_calendar_buf);
        
        if((chi_calendar_buf.w_month == 1) && (chi_calendar_buf.w_day == 1))//ũʮû30
        {
            Lunar_Festival_Flag = 1;
            LunarCalendar_Str = "ǳϦ";
        }
        else if ((chi_calendar_buf.w_month == 12) && (chi_calendar_buf.w_day == 30))
        {
            Lunar_Festival_Flag = 1;
            LunarCalendar_Str = "ǳϦ";
        }
    }
    if((chinacalendar.w_month == 12) && (chinacalendar.w_day == 30))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "ǳϦ";       
    }
    if((chinacalendar.w_month == 1) && (chinacalendar.w_day == 1))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "һ";       
    }
    if((chinacalendar.w_month == 1) && (chinacalendar.w_day == 14))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "Ԫ";       
    }    
    if((chinacalendar.w_month == 1) && (chinacalendar.w_day == 15))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "Ԫڵ";       
    }      
    if((chinacalendar.w_month == 5) && (chinacalendar.w_day == 4))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "";       
    }         
    if((chinacalendar.w_month == 5) && (chinacalendar.w_day == 5))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "ڵ";       
    }  
    if((chinacalendar.w_month == 7) && (chinacalendar.w_day == 6))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "Ϧ";       
    }  
    if((chinacalendar.w_month == 7) && (chinacalendar.w_day == 7))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "ţ֯Ůȵ";       
    }  
    if((chinacalendar.w_month == 8) && (chinacalendar.w_day == 14))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "";       
    }  
    if((chinacalendar.w_month == 8) && (chinacalendar.w_day == 15))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "ѽڵ";       
    }  
    if((chinacalendar.w_month == 9) && (chinacalendar.w_day == 8))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "";       
    }  
    if((chinacalendar.w_month == 9) && (chinacalendar.w_day == 9))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "ڵ";       
    }  
    if((chinacalendar.w_month == 12) && (chinacalendar.w_day == 7))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "˽";       
    } 
    if((chinacalendar.w_month == 12) && (chinacalendar.w_day == 8))
    {
        Lunar_Festival_Flag = 1;
        LunarCalendar_Str = "˽ڵ";       
    } 
}

/*******************************************************************************
 * : void SolarCalendarFestival_Process(void)
 * : մ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
void SolarCalendarFestival_Process(void)
{
    if((calendar.w_month == 1) && (calendar.w_day == 1))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "Ԫ";       
    }
    if((calendar.w_month == 2) && (calendar.w_day == 13))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "˽";       
    }    
    if((calendar.w_month == 2) && (calendar.w_day == 14))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "˽ڵ";       
    }  
    if((calendar.w_month == 3) && (calendar.w_day == 8))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "˸Ůڵ";       
    }  
//    if((calendar.w_month == 3) && (calendar.w_day == 11))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "ֲ";       
//    }  
//    if((calendar.w_month == 3) && (calendar.w_day == 12))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "ֲڵ";       
//    }  
//    if((calendar.w_month == 3) && (calendar.w_day == 15))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "Ȩ";       
//    }  
//    if((calendar.w_month == 4) && (calendar.w_day == 1))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "˽ڡСϵ";       
//    }  
    if((calendar.w_month == 5) && (calendar.w_day == 1))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "Ͷڡ";       
    }  	
//    if((calendar.w_month == 5) && (calendar.w_day == 4))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "ڵ";       
//    } 
//    if((calendar.w_month == 5) && (calendar.w_day == 11))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "ǹʻʿ";       
//    } 
//    if((calendar.w_month == 5) && (calendar.w_day == 12))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "ʹ";       
//    } 
//    if((calendar.w_month == 5) && (calendar.w_day == 5))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "עĸ׽";       
//    } 
//    if((calendar.w_month == 5) && (calendar.w_day == 6))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "עĸ׽";       
//    } 
//    if((calendar.w_month == 5) && (calendar.w_day == 31))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "ͯ";       
//    } 	
//    if((calendar.w_month == 6) && (calendar.w_day == 1))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "һͯڿ";       
//    } 	
//    if((calendar.w_month == 6) && (calendar.w_day == 5))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "绷";       
//    } 	
//    if((calendar.w_month == 6) && (calendar.w_day == 13))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "ע⸸׽";       
//    } 
//    if((calendar.w_month == 6) && (calendar.w_day == 15))
//    {
//        Solar_Festival_Flag = 1;
//        SolarCalendar_Str = "ע⸸׽";       
//    } 
    if((calendar.w_month == 8) && (calendar.w_day == 1))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "һڵ";       
    } 
    if((calendar.w_month == 8) && (calendar.w_day == 15))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "սʤͶ";       
    } 
    if((calendar.w_month == 9) && (calendar.w_day == 9))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "ʦ";       
    } 
    if((calendar.w_month == 9) && (calendar.w_day == 10))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "ڵ԰";       
    } 
    if((calendar.w_month == 9) && (calendar.w_day == 30))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "ǹ";       
    } 
    if((calendar.w_month == 10) && (calendar.w_day == 1))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "ڡ";       
    } 
    if((calendar.w_month == 12) && (calendar.w_day == 23))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "ƽҹ";       
    } 
    if((calendar.w_month == 12) && (calendar.w_day == 24))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "ƽҹ";       
    } 
    if((calendar.w_month == 12) && (calendar.w_day == 25))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "ʥڵ";       
    } 
    if((calendar.w_month == 12) && (calendar.w_day == 31))
    {
        Solar_Festival_Flag = 1;
        SolarCalendar_Str = "Ԫ";       
    } 
}















