#ifndef  __KEY_H__
#define  __KEY_H__

#include "sys.h"

#define PINA PBin(11)// PB10
#define PINB PBin(10)// PB11

#define KEY1 PCin(12)// PC12
#define KEY2 PCin(14)// PC14
#define KEY3 PCin(15)// PC15
#define KEY4 PCin(0) // PC0

//#define  cKey_Connect_NUM          0x03
//#define  L_FUN_NUM                 0x01//ת
//#define  R_FUN_NUM                 0x02//ת

#define KEY1_VAL     0X01
#define KEY2_VAL     0X02
#define KEY3_VAL     0X04
#define KEY4_VAL     0X08

#define KEY_SCAN_INTERVAL_TIME		10//̰ʱ
#define KEY_MAX_BUBBLE_TIME	        1250//ʱ		


extern u8 Disp_Flicker_Flag;
extern u8 Function_Value;


void Flicker_Process(void);
void Key_Init(void);
void EncodeKey_Check(void);
void EncodeKey_Process(void);
void process_key(void);

//void Potentiometer_Scan(void);
//void L_Function(void);
//void R_Function(void);

#endif




