#ifndef  __calendar_h__
#define  __calendar_h__

#include "sys.h"
#include "pcf8563.h"

#define     C51         0
#define     ARM         1  

#define     CPU_TYPE    ARM    // ûݲͬƽָ̨ 51ôӦΪ C51       

#if CPU_TYPE ==  C51           
	   	#define KeyWord	code   // C51code ŵROM
#else
		#define KeyWord	const  // ARMconstŵROM
#endif
/* زõĴ */
#define JieQiEn             1  // 1:ʹܽش
#define ShengXiaoEn         1  // 1:ʹФش
        
extern char CHCalendarStr[14];
extern char Zodiac[2];
extern char SolarTerms[14];
extern u8 SolarTerms_Flag;

extern unsigned char GetChinaCalendar
(
    unsigned int  year,	
    unsigned char month,
    unsigned char day,
    _chinacalendar_obj *p
);
extern void GetWeek
(
    unsigned int year,
    unsigned char month,
    unsigned char day,
    unsigned char *week
);
    
void GetChinaCalendarStr
(
    unsigned int  year,	
    unsigned char month,
    unsigned char day,
             char *str
);
             
extern void GetShengXiaoStr
(
    unsigned int  year,	
    unsigned char month,
    unsigned char day,
    char *str
);	
    
extern unsigned char GetJieQiStr
(
    unsigned int year,
    unsigned char month,
    unsigned char day,
    char *str
);
    
extern unsigned char GetJieQi
(
    unsigned  int year,
    unsigned char month,
    unsigned char day,
    unsigned char *JQdate
);

#endif

